;XtraKeys v.3.00
;Copyright (C) Kevin Kofler, 2000-2005
;please read the readme file before using this file
;Please DO NOT distribute modified versions without my
;permission!

 include "OS.h" ;You need the version included with TIGCC.
_tigcc_native: xdef _tigcc_native ;no kernel required, but startup sections
 xdef _ti89 ;This is for the TI-89.
 xdef _ti92plus ;This is also for the TI-92+.
_v200: xdef _v200 ;and the Voyage 200.

 section "_st1"

 xdef _nostub_data__0000 ;comment
 xdef _nostub_data__0006 ;incompatibility flags

 include "h220xtsr.h"
 movem.l a0-a6/d0-d7,-(a7) ;save all registers
 moveq.l #-5,d1
 moveq.l #16,d3 ;compute offset
 cmp.l d0,d1
 beq hw3
 bset.l #18,d3
hw3:
;Detect the address of the home screen entry line parameters (needed for the
;automatic adding of ans(1) before ^2, ^3 and ^-1).
;Thanks to Samuel Stearley for this one!
 move.l $c8,a0
 move.l TE_select*4(a0),d0 ;get the address of TE_select
 move.l HomeExecute*4(a0),a0 ;get the address of HomeExecute
;The code for HomeExecute contains a jsr to TE_select preceded by a pea of the
;required address.
search_loop:
 addq.l	#2,a0 ;code is word-aligned, so no need to check every byte
 cmp.l (a0),d0 ;compare with the address of TE_select
 bne search_loop
 clr.l d0
 move.w -4(a0),d0 ;get address of the home screen entry line
 add.l #16,d0 ;add 16 to the address to point it to the length of the text
;End of the home screen entry line parameters detection
 pea.l event(PC) ;prepare EV_sendEvent call
 move.w #-2,-(a7)
 move.l $c8,a0
 move.l ScrRect*4(a0),a0
 cmp.b #200,2(a0) ;check if TI-92+/V200
 bcc ti92plus
 move.l $c8,a0 ;check if AMS >= 3.10
 cmp.l #$60d,-4(a0)
 bcc ti89t ;routine for TI-89/Titanium AMS <3.10
 move.l d0,params89
 move.l #$116,event_key ;change the keycode to CATALOG
 ROM_CALL EV_sendEvent ;send the CATALOG keypress
 ROM_CALL2 FirstWindow
 move.l (a4),catalog89 ;get the address of the catalog window
 move.l #$10001108,event_key ;change the keycode to Quit
 ROM_CALL EV_sendEvent ;send the Quit keypress
 addq.l #6,a7
 ROM_CALL cmd_disphome ;switch to the HOME screen
 ROM_CALL2 FirstWindow
 move.l (a4),a4
 addq.l #1,a4
 move.l a4,window89 ;get the address of the home screen window
 ROM_CALL2 EV_hook ;get the location of the event hook
 move.l (a4),oldevent89 ;save the old event hook and call
                        ;it from the event routine
 move.l #(endevent89-newevent89),-(a7)
 ROM_CALL HeapAllocHigh ;allocate a handle for the new
                        ;event routine
 addq.l #2,a7
 tst.w d0 ;check if NULL handle
 beq nomem ;if yes, display "no mem" error message
 move.w d0,(a7)
 ROM_CALL HeapDeref ;get ("dereference") the address
 move.l a0,a3 ;save the address to a3 for further use
 subq.l #2,a7
 move.l #(endevent89-newevent89),(a7)
 pea.l newevent89(PC)
 move.l a0,-(a7)
 ROM_CALL memcpy ;copy the event routine to the handle
 bra install_EV_hook ;jump to common routine for all models
ti89t: ;routine for TI-89 Titanium AMS >=3.10
 move.l d0,params89t
 move.l #$116,event_key ;change the keycode to CATALOG
 dc.w $F800+EV_sendEvent ;send the CATALOG keypress
 ROM_CALL2 FirstWindow
 move.l (a4),catalog89t ;get the address of the catalog window
 move.l #$10001108,event_key ;change the keycode to Quit
 dc.w $F800+EV_sendEvent ;send the Quit keypress
 addq.l #6,a7
 dc.w $F800+cmd_disphome ;switch to the HOME screen
 ROM_CALL2 FirstWindow
 move.l (a4),a4
 addq.l #1,a4
 move.l a4,window89t ;get the address of the home screen window
 pea.l tidsktop(PC)
 dc.w $F800+TIOS_EV_getAppID
 addq.l #4,a7
 move.w d0,tidsktop89t
 ROM_CALL2 EV_hook ;get the location of the event hook
 move.l (a4),oldevent89t ;save the old event hook and call
                         ;it from the event routine
 move.l #(endevent89t-newevent89t),-(a7)
 dc.w $F800+HeapAllocHigh ;allocate a handle for the new
                        ;event routine
 addq.l #2,a7
 tst.w d0 ;check if NULL handle
 beq nomem ;if yes, display "no mem" error message
 move.w d0,(a7)
 dc.w $F800+HeapDeref ;get ("dereference") the address
 move.l a0,a3 ;save the address to a3 for further use
 subq.l #2,a7
 move.l #(endevent89t-newevent89t),(a7)
 pea.l newevent89t(PC)
 move.l a0,-(a7)
 dc.w $F800+memcpy ;copy the event routine to the handle
 bra install_EV_hook ;jump to common routine for all models
ti92plus:
 move.l $c8,a0 ;check if AMS >= 3.10
 cmp.l #$60d,-4(a0)
 bcc v200 ;routine for TI-92+/V200 AMS <3.10
 move.l d0,params92p
 move.l #$10001108,event_key ;change the keycode to Quit
 ROM_CALL EV_sendEvent ;send the Quit keypress
 addq.l #6,a7
 move.l $c8,a0
 cmp.l #cmd_disphome,-4(a0) ;check if cmd_disphome is available
 bls nodisphome ;If it isn't, we are on a TI-92+ AMS 1.00. That means that there
                ;is no icon desktop anyway, so we already are on the home screen.
 move.l cmd_disphome*4(a0),a0
 jsr (a0) ;switch to the HOME screen
nodisphome:
 ROM_CALL2 FirstWindow
 move.l (a4),a4
 addq.l #1,a4
 move.l a4,window92p ;get the address of the home screen window
 ROM_CALL2 EV_hook ;get the location of the event hook
 move.l (a4),oldevent92p ;save the old event hook and call
                         ;it from the event routine
 move.l #(endevent92p-newevent92p),-(a7)
 ROM_CALL HeapAllocHigh ;allocate a handle for the new
                        ;event routine
 addq.l #2,a7
 tst.w d0
 beq nomem
 move.w d0,(a7)
 ROM_CALL HeapDeref ;get ("dereference") the address
 move.l a0,a3 ;save the address to a3 for further use
 subq.l #2,a7
 move.l #(endevent92p-newevent92p),(a7)
 pea.l newevent92p(PC)
 move.l a0,-(a7)
 ROM_CALL memcpy ;copy the event routine to the handle
 bra install_EV_hook ;jump to common routine for all models
v200: ;routine for Voyage 200 AMS >=3.10
 move.l d0,paramsv200
 move.l #$10001108,event_key ;change the keycode to Quit
 dc.w $F800+EV_sendEvent ;send the Quit keypress
 addq.l #6,a7
 dc.w $F800+cmd_disphome ;switch to the HOME screen
 ROM_CALL2 FirstWindow
 move.l (a4),a4
 addq.l #1,a4
 move.l a4,windowv200 ;get the address of the home screen window
 ROM_CALL2 EV_hook ;get the location of the event hook
 move.l (a4),oldeventv200 ;save the old event hook and call
                          ;it from the event routine
 move.l #(endeventv200-neweventv200),-(a7)
 dc.w $F800+HeapAllocHigh ;allocate a handle for the new
                        ;event routine
 addq.l #2,a7
 tst.w d0
 beq nomem
 move.w d0,(a7)
 dc.w $F800+HeapDeref ;get ("dereference") the address
 move.l a0,a3 ;save the address to a3 for further use
 subq.l #2,a7
 move.l #(endeventv200-neweventv200),(a7)
 pea.l neweventv200(PC)
 move.l a0,-(a7)
 dc.w $F800+memcpy ;copy the event routine to the handle
install_EV_hook: ;common routine for all models
 lea.l 12(a7),a7 ;shorter as add(a).l #12,a7
 ROM_CALL2 EV_hook ;get the location of the event hook
 adda.l d3,a3 ;add offset to skip the uninstall information (need the start of
              ;the executable code here)
 move.l a3,(a4) ;install the event hook
 move.l $c8,a0 ;check if AMS >= 3.10
 cmp.l #$60d,-4(a0)
 bcc skipvars ;don't create x\root and x\logy on AMS >=3.10
 pea.l foldersym(PC)
 ROM_CALL FolderFind ;check if the "x" folder exists
 cmp.b #3,d0
 beq skipfolder ;if yes, don't try to create it
 cmp.b #4,d0
 bne skipall ;if error, skip all the rest
 ROM_CALL FolderAdd ;create the "x" folder
 tst.w d0
 beq skipall ;if error, skip all the rest
skipfolder:
 addq.l #4,a7
 pea.l rootsym(PC)
 ROM_CALL SymFind ;check if "x\root" exists
 tst.w d0
 bne skiproot ;if yes, skip
 move.l #19,(a7)
 ROM_CALL HeapAlloc
 tst.w d0
 beq skiproot ;if there is an error, skip
 move.w d0,d3
 move.w d0,(a7)
 ROM_CALL HeapDeref
 clr.w (a7)
 pea.l rootdata(PC)
 pea.l (a0)
 ROM_CALL memcpy
 addq.l #8,a7
 pea.l rootsym(PC)
 ROM_CALL SymAdd ;create the "x\root" function
 tst.w d0
 beq skiproot2 ;if there is an error, skip
 move.l d0,(a7)
 ROM_CALL DerefSym
 move.w d3,12(a0) ;set handle
 clr.l -(a7)
 ROM_CALL EM_moveSymToExtMem ;archive "x\root"
 addq.l #8,a7
skiproot:
 addq.l #4,a7
 pea.l logysym(PC)
 ROM_CALL SymFind ;check if "x\logy" exists
 tst.w d0
 bne skiplogy ;if yes, skip
 move.l #17,(a7)
 ROM_CALL HeapAlloc
 tst.w d0
 beq skiplogy ;if there is an error, skip
 move.w d0,d3
 move.w d0,(a7)
 ROM_CALL HeapDeref
 clr.w (a7)
 pea.l logydata(PC)
 pea.l (a0)
 ROM_CALL memcpy
 addq.l #8,a7
 pea.l logysym(PC)
 ROM_CALL SymAdd ;create the "x\logy" function
 tst.w d0
 beq skiplogy2 ;if there is an error, skip
 move.l d0,(a7)
 ROM_CALL DerefSym
 move.w d3,12(a0) ;set handle
 clr.l -(a7)
 ROM_CALL EM_moveSymToExtMem ;archive "x\logy"
 addq.l #8,a7
skiplogy:
skipall:
 addq.l #4,a7
skipvars:
 pea.l installedST(PC) ;show "installed" message
showmsg:
 ROM_CALL ST_helpMsg
 addq.l #4,a7
 movem.l (a7)+,a0-a6/d0-d7 ;restore all registers
 rts ;return
skiproot2:
 move.w d3,(a7)
 ROM_CALL HeapFree ;remove handle in case of error
 bra skiproot
skiplogy2:
 move.w d3,(a7)
 ROM_CALL HeapFree ;remove handle in case of error
 bra skiplogy
nomem:
 addq.l #2,a7 ;adjust the stack
 pea.l nomemST(PC) ;show "no mem" message
 bra showmsg

;word-aligned data here
event: ;event structure for EV_sendEvent
 dc.w $710 ;type = CM_STRING
 ds.b 6 ;RunningApp (2), Side (2), StatusFlags (2)
event_key:
 dc.w $0,$116,0 ;Mod, Code, StartType (2)
_nostub_data__0006: ;incompatibility flags
 dc.l 11 ;incompatible with handle freeing, EV_hook and trap restoring

newevent89: ;event hook for TI-89/Titanium AMS <3.10
 dc.b 'evHkXtraKeys' ;signature "evHk" + program name
                     ;(for event hook uninstaller)
oldevent89: dc.l 0 ;placeholder for old event hook
                   ;0 if none
                   ;placed here for easier and
                   ;program- and version-independent
                   ;uninstalling
 movem.l a0-a6/d0-d7,-(a7) ;save all registers
 move.l 64(a7),a2 ;a2=event structure address (a2 for TEOS)
 cmp.w #$700,(a2) ;check if CM_IDLE or CM_BLINK
 beq idle89
 cmp.w #$740,(a2)
 bne notidle89
idle89:
 lea.l statusflags89(PC),a0 ;if yes, save the status flags
 move.w (a0),2(a0)
 move.w 6(a2),(a0)
notidle89:
 cmp.w #$710,(a2) ;check if CM_KEYPRESS
 bne notkeypress89 ;if not, do nothing
 move.w 10(a2),d5 ;d5 = keycode
 move.b accenttype89(PC),d1 ;d1 = accent type
 tst.b d1 ;check if there is an accent
 beq noaccent89 ;if not, skip
 cmp.w #'a',d5 ;check if a
 bne notminusa89
 cmp.b #1,d1 ;check if acute accent
 bne minusanotacute89
 move.w #225,10(a2) ;change key code to ""
 bra endaccent89
minusanotacute89:
 cmp.b #2,d1 ;check if grave accent
 bne minusanotgrave89
 move.w #224,10(a2) ;change key code to ""
 bra endaccent89
minusanotgrave89:
 cmp.b #3,d1 ;check if circumflex accent
 bne minusanotcircumflex89
 move.w #226,10(a2) ;change key code to ""
 bra endaccent89
minusanotcircumflex89:
 cmp.b #4,d1 ;check if trema
 bne minusanottrema89
 move.w #228,10(a2) ;change key code to ""
 bra endaccent89
minusanottrema89:
 move.w #227,10(a2) ;change key code to ""
 bra endaccent89
notminusa89:
 cmp.w #'e',d5 ;check if e
 bne notminuse89
 cmp.b #1,d1 ;check if acute accent
 bne minusenotacute89
 move.w #233,10(a2) ;change key code to ""
 bra endaccent89
minusenotacute89:
 cmp.b #2,d1 ;check if grave accent
 bne minusenotgrave89
 move.w #232,10(a2) ;change key code to ""
 bra endaccent89
minusenotgrave89:
 cmp.b #3,d1 ;check if circumflex accent
 bne minusenotcircumflex89
 move.w #234,10(a2) ;change key code to ""
 bra endaccent89
minusenotcircumflex89:
 cmp.b #4,d1 ;check if trema
 bne invalidaccent89
 move.w #235,10(a2) ;change key code to ""
 bra endaccent89
notminuse89:
 cmp.w #'i',d5 ;check if i
 bne notminusi89
 cmp.b #1,d1 ;check if acute accent
 bne minusinotacute89
 move.w #237,10(a2) ;change key code to ""
 bra endaccent89
minusinotacute89:
 cmp.b #2,d1 ;check if grave accent
 bne minusinotgrave89
 move.w #236,10(a2) ;change key code to ""
 bra endaccent89
minusinotgrave89:
 cmp.b #3,d1 ;check if circumflex accent
 bne minusinotcircumflex89
 move.w #238,10(a2) ;change key code to ""
 bra endaccent89
minusinotcircumflex89:
 cmp.b #4,d1 ;check if trema
 bne invalidaccent89
 move.w #239,10(a2) ;change key code to ""
 bra endaccent89
notminusi89:
 cmp.w #'o',d5 ;check if o
 bne notminuso89
 cmp.b #1,d1 ;check if acute accent
 bne minusonotacute89
 move.w #243,10(a2) ;change key code to ""
 bra endaccent89
minusonotacute89:
 cmp.b #2,d1 ;check if grave accent
 bne minusonotgrave89
 move.w #242,10(a2) ;change key code to ""
 bra endaccent89
minusonotgrave89:
 cmp.b #3,d1 ;check if circumflex accent
 bne minusonotcircumflex89
 move.w #244,10(a2) ;change key code to ""
 bra endaccent89
minusonotcircumflex89:
 cmp.b #4,d1 ;check if trema
 bne minusonottrema89
 move.w #246,10(a2) ;change key code to ""
 bra endaccent89
minusonottrema89:
 move.w #245,10(a2) ;change key code to ""
 bra endaccent89
notminuso89:
 cmp.w #'u',d5 ;check if u
 bne notminusu89
 cmp.b #1,d1 ;check if acute accent
 bne minusunotacute89
 move.w #250,10(a2) ;change key code to ""
 bra endaccent89
minusunotacute89:
 cmp.b #2,d1 ;check if grave accent
 bne minusunotgrave89
 move.w #249,10(a2) ;change key code to ""
 bra endaccent89
minusunotgrave89:
 cmp.b #3,d1 ;check if circumflex accent
 bne minusunotcircumflex89
 move.w #251,10(a2) ;change key code to ""
 bra endaccent89
minusunotcircumflex89:
 cmp.b #4,d1 ;check if trema
 bne invalidaccent89
 move.w #252,10(a2) ;change key code to ""
 bra endaccent89
notminusu89:
 cmp.w #'y',d5 ;check if y
 bne notminusy89
 cmp.b #1,d1 ;check if acute accent
 bne minusynotacute89
 move.w #253,10(a2) ;change key code to ""
 bra endaccent89
minusynotacute89:
 cmp.b #4,d1 ;check if trema
 bne invalidaccent89
 move.w #255,10(a2) ;change key code to ""
 bra endaccent89
notminusy89:
 cmp.w #'n',d5 ;check if n
 bne notminusn89
 cmp.b #5,d1 ;check if tilde
 bne invalidaccent89
 move.w #241,10(a2) ;change key code to ""
 bra endaccent89  
notminusn89:
 cmp.w #'A',d5 ;check if A
 bne notcapsa89
 cmp.b #1,d1 ;check if acute accent
 bne capsanotacute89
 move.w #193,10(a2) ;change key code to ""
 bra endaccent89
capsanotacute89:
 cmp.b #2,d1 ;check if grave accent
 bne capsanotgrave89
 move.w #192,10(a2) ;change key code to ""
 bra endaccent89
capsanotgrave89:
 cmp.b #3,d1 ;check if circumflex accent
 bne capsanotcircumflex89
 move.w #194,10(a2) ;change key code to ""
 bra endaccent89
capsanotcircumflex89:
 cmp.b #4,d1 ;check if trema
 bne capsanottrema89
 move.w #196,10(a2) ;change key code to ""
 bra endaccent89
capsanottrema89:
 move.w #195,10(a2) ;change key code to ""
 bra endaccent89
notcapsa89:
 cmp.w #'E',d5 ;check if E
 bne notcapse89
 cmp.b #1,d1 ;check if acute accent
 bne capsenotacute89
 move.w #201,10(a2) ;change key code to ""
 bra endaccent89
capsenotacute89:
 cmp.b #2,d1 ;check if grave accent
 bne capsenotgrave89
 move.w #200,10(a2) ;change key code to ""
 bra endaccent89
capsenotgrave89:
 cmp.b #3,d1 ;check if circumflex accent
 bne capsenotcircumflex89
 move.w #202,10(a2) ;change key code to ""
 bra endaccent89
capsenotcircumflex89:
 cmp.b #4,d1 ;check if trema
 bne invalidaccent89
 move.w #203,10(a2) ;change key code to ""
 bra endaccent89
notcapse89:
 cmp.w #'I',d5 ;check if I
 bne notcapsi89
 cmp.b #1,d1 ;check if acute accent
 bne capsinotacute89
 move.w #205,10(a2) ;change key code to ""
 bra endaccent89
capsinotacute89:
 cmp.b #2,d1 ;check if grave accent
 bne capsinotgrave89
 move.w #204,10(a2) ;change key code to ""
 bra endaccent89
capsinotgrave89:
 cmp.b #3,d1 ;check if circumflex accent
 bne capsinotcircumflex89
 move.w #206,10(a2) ;change key code to ""
 bra endaccent89
capsinotcircumflex89:
 cmp.b #4,d1 ;check if trema
 bne invalidaccent89
 move.w #207,10(a2) ;change key code to ""
 bra endaccent89
notcapsi89:
 cmp.w #'O',d5 ;check if O
 bne notcapso89
 cmp.b #1,d1 ;check if acute accent
 bne capsonotacute89
 move.w #211,10(a2) ;change key code to ""
 bra endaccent89
capsonotacute89:
 cmp.b #2,d1 ;check if grave accent
 bne capsonotgrave89
 move.w #210,10(a2) ;change key code to ""
 bra endaccent89
capsonotgrave89:
 cmp.b #3,d1 ;check if circumflex accent
 bne capsonotcircumflex89
 move.w #212,10(a2) ;change key code to ""
 bra endaccent89
capsonotcircumflex89:
 cmp.b #4,d1 ;check if trema
 bne capsonottrema89
 move.w #214,10(a2) ;change key code to ""
 bra endaccent89
capsonottrema89:
 move.w #213,10(a2) ;change key code to ""
 bra endaccent89
notcapso89:
 cmp.w #'U',d5 ;check if U
 bne notcapsu89
 cmp.b #1,d1 ;check if acute accent
 bne capsunotacute89
 move.w #218,10(a2) ;change key code to ""
 bra endaccent89
capsunotacute89:
 cmp.b #2,d1 ;check if grave accent
 bne capsunotgrave89
 move.w #217,10(a2) ;change key code to ""
 bra endaccent89
capsunotgrave89:
 cmp.b #3,d1 ;check if circumflex accent
 bne capsunotcircumflex89
 move.w #219,10(a2) ;change key code to ""
 bra endaccent89
capsunotcircumflex89:
 cmp.b #4,d1 ;check if trema
 bne invalidaccent89
 move.w #220,10(a2) ;change key code to ""
 bra endaccent89
notcapsu89:
 cmp.w #'Y',d5 ;check if Y
 bne notcapsy89
 cmp.b #1,d1 ;check if acute accent
 bne invalidaccent89
 move.w #221,10(a2) ;change key code to ""
 bra endaccent89
notcapsy89:
 cmp.w #'N',d5 ;check if N
 bne notcapsn89
 cmp.b #5,d1 ;check if tilde
 bne invalidaccent89
 move.w #209,10(a2) ;change key code to ""
 bra endaccent89  
notcapsn89:
invalidaccent89:
 move.w #$700,(a2) ;change event to CM_IDLE
endaccent89:
 lea.l accenttype89(PC),a0
 clr.b (a0) ;delete accent
 bra notkeypress89 ;do nothing more
noaccent89:
 ROM_CALL2 FirstWindow
 move.l (a4),a4
 cmp.l catalog89(PC),a4 ;check if the catalog is active
 beq notkeypress89 ;if yes, don't interfere with it
;"rowread" routine
 move.w #$700,-(a7)
 ROM_CALL OSSetSR ;disable interrupts
 move.w #$fe,$600018 ;read the keyboard directly to get the
 nop                 ;info TI's event stucture doesn't give
 nop                 ;out (The key modifiers are not given
 nop                 ;if we need them, only if we don't
 nop                 ;need them. Don't ask me why.)
 nop
 nop
 nop
 nop
 nop
 nop
 nop ;The return value is automatically put in $60001b by
 nop ;the hardware.
 move.b $60001b,d3 ;save the result of rowread to d3
 clr.w (a7)
 ROM_CALL OSSetSR ;reenable interrupts
 addq.l #2,a7
 move.w statusflags289(PC),d1 ;d1 = status flags
 cmp.w #$107,d5 ;check if CLEAR
 bne notclear89
 btst.l #0,d1 ;check if sequential 2nd+CLEAR
 bne clear2nd89
 btst.b #4,d3 ;check if simultaneous 2nd+CLEAR
 bne notclear89
clear2nd89:
 move.w #$723,(a2) ;change event to CM_STRING
 move.l window89(PC),a3 ;check if home screen is active
 btst.b #7,(a3)
 beq simpleinv89
 move.l params89(PC),a3
 btst.b #1,16(a3) ;if yes, check if cursor is in entry line
 beq simpleinv89
 tst.w (a3) ;if yes, check if ans(1) should be added
 beq ansinv89
 btst.b #5,17(a3)
 beq simpleinv89
 tst.w 6(a3)
 bne notbeginning189
 move.w 2(a3),d2
 cmp.w (a3),d2
 bne simpleinv89
 bra ansinv89
notbeginning189:
 tst.w 2(a3)
 bne simpleinv89
 move.w 6(a3),d2
 cmp.w (a3),d2
 bne simpleinv89
ansinv89:
 move.l #$1000b,-(a7)
 pea.l ans1tag89(PC)
 ROM_CALL Parse1DExpr ;convert ans(1) to local string
 addq.l #8,a7
 tst.w d0 ;check if NULL handle
 beq simpleinv89 ;if yes, don't add ans(1)
 move.w d0,-(a7)
 ROM_CALL HeapDeref
 lea.l funcbuffer89(PC),a1
 move.l a1,a3
ansinvnext89: ;add ^-1 to ans(1)
 move.b (a0),(a1)+
 cmp.b #')',(a0)+
 bne ansinvnext89
 move.b #'^',(a1)+
 move.b #173,(a1)+
 move.b #'1',(a1)+
 clr.b (a1)
 ROM_CALL HeapFree
 addq.l #2,a7
 move.l a3,8(a2)
 bra notkeypress89 ;do nothing more
simpleinv89:
 lea.l txt_inv89(PC),a0 ;insert ^-1
 move.l a0,8(a2)
 bra notkeypress89 ;do nothing more
notclear89:
 cmp.w #$115,d5 ;check if HOME
 bne nothome89
 btst.l #2,d1 ;check if sequential DIAMOND+HOME
 bne homediam89
 btst.b #6,d3 ;check if simultaneous DIAMOND+HOME
 bne nothomed89
homediam89:
 move.w #$723,(a2) ;change event to CM_STRING
 lea.l txt_10exp89(PC),a0 ;insert 10^(
 move.l a0,8(a2)
 bra notkeypress89 ;do nothing more
nothomed89:
 btst.l #1,d1 ;check if sequential SHIFT+HOME
 bne homeshift89
 btst.l #4,d1 ;check if CAPS lock+HOME
 bne homeshift89
 btst.b #5,d3 ;check if simultaneous SHIFT+HOME
 bne nothome89
homeshift89:
 lea.l accenttype89(PC),a0
 move.b #5,(a0) ;tilde
 move.w #$700,(a2) ;change event to CM_IDLE
 bra notkeypress89 ;do nothing more
nothome89:
 cmp.w #$4107,d5 ;check if DIAMOND+CLEAR
 bne notdiamclear89
 move.l #$1000a,-(a7)
 pea.l logtag89(PC)
 ROM_CALL Parse1DExpr ;convert log to local string
 addq.l #8,a7
 tst.w d0 ;check if NULL handle
 beq notkeypress89 ;if yes, don't treat the keypress
 move.w d0,-(a7)
 ROM_CALL HeapDeref
 lea.l funcbuffer89(PC),a1
 move.l a1,a3
lognext89:
 move.b (a0),(a1)+
 cmp.b #'(',(a0)+
 bne lognext89
 clr.b (a1)
 ROM_CALL HeapFree
 addq.l #2,a7
 lea.l event_string89(PC),a0 ;insert the address of the log( string into the
 move.l a3,(a0)              ;placeholder in the event structure
 pea.l event89(PC)
 move.w #-2,-(a7)
 ROM_CALL EV_sendEvent ;send the CM_STRING event to the current application
 addq.l #6,a7 ;We have to send an additional event because we have to keep the
              ;self-test key working.
 bra notkeypress89 ;do nothing more
notdiamclear89:
 cmp.w #$10c,d5 ;check if F1
 bne notf189
 btst.l #1,d1 ;check if sequential SHIFT+F1
 bne f1shift89
 btst.l #4,d1 ;check if CAPS lock+F1
 bne f1shift89
 btst.b #5,d3 ;check if simultaneous SHIFT+F1
 bne notf1s89
f1shift89:
 move.l #3000,-(a7)
 ROM_CALL HeapAllocPtr
 move.l a0,d4 ;save the address to d4
 tst.l d4
 beq f1shiftnomem89 ;if NULL pointer, don't display key map
 move.l #$4c00,-(a7)
 move.l d4,-(a7)
 ROM_CALL memcpy ;save the screen
 addq.l #6,a7
 move.w #4,(a7)
 pea.l keymapclip89(PC)
 pea.l keymap89(PC)
 clr.l -(a7)
 ROM_CALL BitmapPut ;display the key map
 lea.l 10(a7),a7
 ROM_CALL ngetchx ;wait for a keypress
 move.l d4,(a7)
 move.l #$4c00,-(a7)
 ROM_CALL memcpy ;restore the screen
 addq.l #4,a7
 ROM_CALL HeapFreePtr
 addq.l #4,a7
f1shiftnomem89:
 addq.l #4,a7
 move.w #$700,(a2) ;change event to CM_IDLE
 bra notkeypress89 ;do nothing more
notf1s89:
 btst.l #3,d1 ;check if sequential alpha+F1
 bne f1alpha89
 btst.l #5,d1 ;check if alpha lock+F1
 bne f1alpha89
 btst.b #7,d3 ;check if simultaneous alpha+F1
 bne notf189
f1alpha89:
 lea.l accenttype89(PC),a0
 move.b #1,(a0) ;acute accent
 move.w #$700,(a2) ;change event to CM_IDLE
 bra notkeypress89 ;do nothing more
notf189:
 cmp.w #$10d,d5 ;check if F2
 bne notf289
 btst.l #1,d1 ;check if sequential SHIFT+F2
 bne f2shift89
 btst.l #4,d1 ;check if CAPS lock+F2
 bne f2shift89
 btst.b #5,d3 ;check if simultaneous SHIFT+F2
 bne notf2s89
f2shift89:
 move.l #$1000a,-(a7)
 pea.l abstag89(PC)
 ROM_CALL Parse1DExpr ;convert abs to local string
 addq.l #8,a7
 tst.w d0 ;check if NULL handle
 beq notkeypress89 ;if yes, don't treat the keypress
 move.w d0,-(a7)
 ROM_CALL HeapDeref
 lea.l funcbuffer89(PC),a1
 move.l a1,a3
absnext89:
 move.b (a0),(a1)+
 cmp.b #'(',(a0)+
 bne absnext89
 clr.b (a1)
 ROM_CALL HeapFree
 addq.l #2,a7
 move.w #$723,(a2) ;change event to CM_STRING
 move.l a3,8(a2) ;insert abs(
 bra notkeypress89 ;do nothing more
notf2s89:
 btst.l #3,d1 ;check if sequential alpha+F2
 bne f2alpha89
 btst.l #5,d1 ;check if alpha lock+F2
 bne f2alpha89
 btst.b #7,d3 ;check if simultaneous alpha+F2
 bne notf289
f2alpha89:
 lea.l accenttype89(PC),a0
 move.b #2,(a0) ;grave accent
 move.w #$700,(a2) ;change event to CM_IDLE
 bra notkeypress89 ;do nothing more
notf289:
 cmp.w #$10e,d5 ;check if F3
 bne notf389
 btst.l #1,d1 ;check if sequential SHIFT+F3
 bne f3shift89
 btst.l #4,d1 ;check if CAPS lock+F3
 bne f3shift89
 btst.b #5,d3 ;check if simultaneous SHIFT+F3
 bne notf3s89
f3shift89:
 move.l #$1000a,-(a7)
 pea.l ncrtag89(PC)
 ROM_CALL Parse1DExpr ;convert nCr to local string
 addq.l #8,a7
 tst.w d0 ;check if NULL handle
 beq notkeypress89 ;if yes, don't treat the keypress
 move.w d0,-(a7)
 ROM_CALL HeapDeref
 lea.l funcbuffer89(PC),a1
 move.l a1,a3
ncrnext89:
 move.b (a0),(a1)+
 cmp.b #'(',(a0)+
 bne ncrnext89
 clr.b (a1)
 ROM_CALL HeapFree
 addq.l #2,a7
 move.w #$723,(a2) ;change event to CM_STRING
 move.l a3,8(a2) ;insert nCr(
 bra notkeypress89 ;do nothing more
notf3s89:
 btst.l #3,d1 ;check if sequential alpha+F3
 bne f3alpha89
 btst.l #5,d1 ;check if alpha lock+F3
 bne f3alpha89
 btst.b #7,d3 ;check if simultaneous alpha+F3
 bne notf389
f3alpha89:
 lea.l accenttype89(PC),a0
 move.b #3,(a0) ;circumflex accent
 move.w #$700,(a2) ;change event to CM_IDLE
 bra notkeypress89 ;do nothing more
notf389:
 cmp.w #$10f,d5 ;check if F4
 bne notf489
 btst.l #0,d1 ;check if sequential 2nd+F4
 bne f42nd89
 btst.b #4,d3 ;check if simultaneous 2nd+F4
 bne notf4289
f42nd89:
 move.w #$723,(a2) ;change event to CM_STRING
 move.l window89(PC),a3 ;check if home screen is active
 btst.b #7,(a3)
 beq simplesquare89
 move.l params89(PC),a3
 btst.b #1,16(a3) ;if yes, check if cursor is in entry line
 beq simplesquare89
 tst.w (a3) ;if yes, check if ans(1) should be added
 beq anssquare89
 btst.b #5,17(a3)
 beq simplesquare89
 tst.w 6(a3)
 bne notbeginning289
 move.w 2(a3),d2
 cmp.w (a3),d2
 bne simplesquare89
 bra anssquare89
notbeginning289:
 tst.w 2(a3)
 bne simplesquare89
 move.w 6(a3),d2
 cmp.w (a3),d2
 bne simplesquare89
anssquare89:
 move.l #$1000b,-(a7)
 pea.l ans1tag89(PC)
 ROM_CALL Parse1DExpr ;convert ans(1) to local string
 addq.l #8,a7
 tst.w d0 ;check if NULL handle
 beq simplesquare89 ;if yes, don't add ans(1)
 move.w d0,-(a7)
 ROM_CALL HeapDeref
 lea.l funcbuffer89(PC),a1
 move.l a1,a3
anssquarenext89: ;add ^2 to ans(1)
 move.b (a0),(a1)+
 cmp.b #')',(a0)+
 bne anssquarenext89
 move.b #'^',(a1)+
 move.b #'2',(a1)+
 clr.b (a1)
 ROM_CALL HeapFree
 addq.l #2,a7
 move.l a3,8(a2)
 bra notkeypress89 ;do nothing more
simplesquare89:
 lea.l txt_square89(PC),a0 ;insert ^2
 move.l a0,8(a2)
 bra notkeypress89 ;do nothing more
notf4289:
 btst.l #1,d1 ;check if sequential SHIFT+F4
 bne f4shift89
 btst.l #4,d1 ;check if CAPS lock+F4
 bne f4shift89
 btst.b #5,d3 ;check if simultaneous SHIFT+F4
 bne notf4s89
f4shift89:
 move.l #$1000a,-(a7)
 pea.l nprtag89(PC)
 ROM_CALL Parse1DExpr ;convert nPr to local string
 addq.l #8,a7
 tst.w d0 ;check if NULL handle
 beq notkeypress89 ;if yes, don't treat the keypress
 move.w d0,-(a7)
 ROM_CALL HeapDeref
 lea.l funcbuffer89(PC),a1
 move.l a1,a3
nprnext89:
 move.b (a0),(a1)+
 cmp.b #'(',(a0)+
 bne nprnext89
 clr.b (a1)
 ROM_CALL HeapFree
 addq.l #2,a7
 move.w #$723,(a2) ;change event to CM_STRING
 move.l a3,8(a2) ;insert nPr(
 bra notkeypress89 ;do nothing more
notf4s89:
 btst.l #3,d1 ;check if sequential alpha+F4
 bne f4alpha89
 btst.l #5,d1 ;check if alpha lock+F4
 bne f4alpha89
 btst.b #7,d3 ;check if simultaneous alpha+F4
 bne notf489
f4alpha89:
 lea.l accenttype89(PC),a0
 move.b #4,(a0) ;trema or german Umlaut
 move.w #$700,(a2) ;change event to CM_IDLE
 bra notkeypress89 ;do nothing more
notf489:
 cmp.w #$110,d5 ;check if F5
 bne notf589
 btst.l #0,d1 ;check if sequential 2nd+F5
 bne f52nd89
 btst.b #4,d3 ;check if simultaneous 2nd+F5
 bne notf5289
f52nd89:
 move.w #$723,(a2) ;change event to CM_STRING
 move.l window89(PC),a3 ;check if home screen is active
 btst.b #7,(a3)
 beq simplecube89
 move.l params89(PC),a3
 btst.b #1,16(a3) ;if yes, check if cursor is in entry line
 beq simplecube89
 tst.w (a3) ;if yes, check if ans(1) should be added
 beq anscube89
 btst.b #5,17(a3)
 beq simplecube89
 tst.w 6(a3)
 bne notbeginning389
 move.w 2(a3),d2
 cmp.w (a3),d2
 bne simplecube89
 bra anscube89
notbeginning389:
 tst.w 2(a3)
 bne simplecube89
 move.w 6(a3),d2
 cmp.w (a3),d2
 bne simplecube89
anscube89:
 move.l #$1000b,-(a7)
 pea.l ans1tag89(PC)
 ROM_CALL Parse1DExpr ;convert ans(1) to local string
 addq.l #8,a7
 tst.w d0 ;check if NULL handle
 beq simplecube89 ;if yes, don't add ans(1)
 move.w d0,-(a7)
 ROM_CALL HeapDeref
 lea.l funcbuffer89(PC),a1
 move.l a1,a3
anscubenext89: ;add ^3 to ans(1)
 move.b (a0),(a1)+
 cmp.b #')',(a0)+
 bne anscubenext89
 move.b #'^',(a1)+
 move.b #'3',(a1)+
 clr.b (a1)
 ROM_CALL HeapFree
 addq.l #2,a7
 move.l a3,8(a2)
 bra notkeypress89 ;do nothing more
simplecube89:
 lea.l txt_cube89(PC),a0 ;insert ^3
 move.l a0,8(a2)
 bra notkeypress89 ;do nothing more
notf5289:
 btst.l #1,d1 ;check if sequential SHIFT+F5
 bne f5shift89
 btst.l #4,d1 ;check if CAPS lock+F5
 bne f5shift89
 btst.b #5,d3 ;check if simultaneous SHIFT+F5
 bne notf5s89
f5shift89:
 move.w #$723,(a2) ;change event to CM_STRING
 lea.l txt_sigma89(PC),a0 ;insert SIGMA(
 move.l a0,8(a2)
 bra notkeypress89 ;do nothing more
notf5s89:
 btst.l #3,d1 ;check if sequential alpha+F5
 bne f5alpha89
 btst.l #5,d1 ;check if alpha lock+F5
 bne f5alpha89
 btst.b #7,d3 ;check if simultaneous alpha+F5
 bne notf589
f5alpha89:
 move.w #223,10(a2) ;change key code to german sz
 bra notkeypress89 ;do nothing more
notf589:
 cmp.w #$5e,d5 ;check if ^
 bne notpower89
 btst.l #1,d1 ;check if sequential SHIFT+^
 bne powershift89
 btst.l #4,d1 ;check if CAPS lock+^
 bne powershift89
 btst.b #5,d3 ;check if simultaneous SHIFT+^
 bne notpowers89
powershift89:
 move.w #$723,(a2) ;change event to CM_STRING
 lea.l txt_xlog89(PC),a0 ;insert x\logy(
 move.l a0,8(a2)
 bra notkeypress89 ;do nothing more
notpowers89:
 btst.l #3,d1 ;check if sequential alpha+^
 bne poweralpha89
 btst.l #5,d1 ;check if alpha lock+^
 bne poweralpha89
 btst.b #7,d3 ;check if simultaneous alpha+^
 bne notpower89
poweralpha89:
 move.w #$723,(a2) ;change event to CM_STRING
 lea.l txt_xroot89(PC),a0 ;insert x\root(
 move.l a0,8(a2)
 bra notkeypress89 ;do nothing more
notpower89:
 cmp.w #$10a,d5 ;check if MODE
 bne notmode89
 btst.l #1,d1 ;check if sequential SHIFT+MODE
 bne modeshift89
 btst.l #4,d1 ;check if CAPS lock+MODE
 bne modeshift89
 btst.b #5,d3 ;check if simultaneous SHIFT+MODE
 bne notmodes89
modeshift89:
 move.w #'#',10(a2) ;change key code to "#"
 bra notkeypress89 ;do nothing more
notmodes89:
 btst.l #3,d1 ;check if sequential alpha+MODE
 bne modealpha89
 btst.l #5,d1 ;check if alpha lock+MODE
 bne modealpha89
 btst.b #7,d3 ;check if simultaneous alpha+MODE
 bne notmode89
modealpha89:
 move.w #'?',10(a2) ;change key code to "?"
 bra notkeypress89 ;do nothing more
notmode89:
 cmp.w #$109,d5 ;check if APPS
 bne notapps89
 btst.l #1,d1 ;check if sequential SHIFT+APPS
 bne appsshift89
 btst.l #4,d1 ;check if CAPS lock+APPS
 bne appsshift89
 btst.b #5,d3 ;check if simultaneous SHIFT+APPS
 bne notappss89
appsshift89:
 move.w #199,10(a2) ;change key code to C cedilla
 bra notkeypress89 ;do nothing more
notappss89:
 btst.l #3,d1 ;check if sequential alpha+APPS
 bne appsalpha89
 btst.l #5,d1 ;check if alpha lock+APPS
 bne appsalpha89
 btst.b #7,d3 ;check if simultaneous alpha+APPS
 bne notapps89
appsalpha89:
 move.w #231,10(a2) ;change key code to c cedilla
 bra notkeypress89 ;do nothing more
notapps89:
 cmp.w #$116,d5 ;check if CATALOG
 bne notkeypress89
 btst.l #1,d1 ;check if sequential SHIFT+CATALOG
 bne catalogshift89
 btst.l #4,d1 ;check if CAPS lock+CATALOG
 bne catalogshift89
 btst.b #5,d3 ;check if simultaneous SHIFT+CATALOG
 bne notkeypress89
catalogshift89:
 move.w #150,10(a2) ;change key code to Napier/Euler e
notkeypress89:
 move.l oldevent89(PC),a0 ;a0 = old event hook
 cmp.l #0,a0 ;check if 0 (tst refuses this addressing mode)
 beq nooldevent89 ;if 0 do nothing
 move.l a2,-(a7) ;pass event structure as an argument
 jsr (a0) ;run the old event hook
 addq.l #4,a7
nooldevent89:
 movem.l (a7)+,a0-a6/d0-d7 ;restore all registers
 rts ;return
 EVEN ;avoid silly alignment problems
      ;("Address Error" etc.)
statusflags89: dc.w 0 ;placeholder for the status flags
statusflags289: dc.w 0
params89: dc.l $6016 ;position of the home screen entry line
                     ;parameters
window89: dc.l $6071 ;position of the 2nd byte of the home
                     ;screen window flags (containing the
                     ;"active" flag)
catalog89: dc.l 0 ;position of the catalog window flags
;Those values may be adjusted for different AMS versions.
event89: ;event structure for EV_sendEvent
 dc.w $723 ;type = CM_STRING
 ds.b 6 ;RunningApp (2), Side (2), StatusFlags (2)
event_string89:
 ds.b 6 ;pasteText (4), StartType (2)
keymapclip89: dc.b 0,0,159,99
keymap89:
 dc.w 100,160
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $39,$81,$5d,$4c,$3b,$80,$00,$80,$39,$00,$00,$60,$11,$00,$00,$c0,$13,$00,$00,$3c
 dc.b $22,$01,$51,$50,$20,$80,$06,$cc,$22,$80,$00,$80,$2a,$80,$00,$a0,$28,$80,$00,$10
 dc.b $33,$01,$98,$88,$30,$80,$0a,$a8,$31,$00,$0c,$8c,$00,$80,$0c,$cc,$03,$00,$00,$08
 dc.b $22,$81,$50,$84,$21,$00,$0a,$a4,$22,$80,$0a,$88,$01,$00,$0a,$88,$00,$80,$00,$10
 dc.b $21,$01,$5c,$98,$22,$00,$06,$cc,$21,$00,$0a,$68,$03,$80,$0a,$88,$03,$00,$00,$3c
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$04,$00,$00,$00,$08,$00,$00,$00,$08,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$08,$00,$00,$00,$04,$00,$00,$00,$14,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $28,$00,$00,$00,$2a,$96,$54,$00,$1b,$13,$28,$00,$3a,$26,$08,$14,$39,$32,$38,$18
 dc.b $2b,$80,$00,$08,$2a,$d5,$54,$0c,$22,$aa,$a8,$08,$12,$28,$48,$00,$12,$aa,$20,$24
 dc.b $10,$00,$00,$14,$2a,$f5,$54,$14,$2b,$3b,$38,$14,$13,$24,$ac,$14,$13,$b2,$30,$28
 dc.b $13,$80,$00,$18,$2a,$b5,$54,$14,$2a,$aa,$28,$14,$12,$a2,$c8,$14,$12,$aa,$20,$24
 dc.b $10,$00,$00,$0c,$14,$96,$28,$0c,$12,$aa,$28,$08,$13,$2c,$6c,$1c,$12,$b3,$b8,$28
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$03,$ff,$ff,$c0
 dc.b $1c,$00,$00,$38,$1c,$00,$00,$38,$1c,$00,$00,$38,$1c,$00,$00,$38,$1c,$00,$00,$38
 dc.b $20,$0e,$10,$04,$20,$0e,$60,$04,$20,$0e,$60,$04,$20,$0e,$50,$04,$20,$0e,$f0,$04
 dc.b $40,$08,$30,$02,$40,$08,$90,$02,$40,$08,$10,$02,$40,$08,$50,$02,$40,$08,$80,$02
 dc.b $40,$08,$50,$02,$40,$08,$10,$02,$40,$08,$60,$02,$40,$08,$90,$02,$40,$08,$e0,$02
 dc.b $40,$0e,$10,$02,$40,$0e,$20,$02,$40,$0e,$10,$02,$40,$0e,$f0,$02,$40,$0e,$10,$02
 dc.b $40,$08,$10,$02,$40,$08,$40,$02,$40,$08,$10,$02,$40,$08,$10,$02,$40,$08,$10,$02
 dc.b $20,$08,$10,$04,$20,$08,$f0,$04,$20,$08,$60,$04,$20,$08,$10,$04,$20,$08,$e0,$04
 dc.b $1c,$00,$00,$38,$1c,$00,$00,$38,$1c,$00,$00,$38,$1c,$00,$00,$38,$1c,$00,$00,$38
 dc.b $03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$03,$ff,$ff,$c0
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$7f,$c0,$00,$00,$00,$0f,$ff,$c0,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$3f,$ff,$c0,$0c,$00,$00,$70,$00,$38,$00,$00,$00
 dc.b $ff,$ff,$ff,$ff,$ff,$ff,$00,$00,$20,$60,$c0,$10,$00,$03,$80,$f8,$07,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$01,$00,$00,$22,$68,$c0,$10,$00,$1c,$03,$06,$00,$e0,$00,$00
 dc.b $00,$00,$80,$00,$00,$21,$00,$00,$27,$fc,$c0,$10,$00,$e0,$04,$21,$00,$1c,$00,$00
 dc.b $03,$39,$80,$00,$00,$71,$00,$00,$22,$68,$c0,$0c,$03,$00,$08,$70,$80,$02,$00,$00
 dc.b $04,$aa,$80,$00,$00,$f9,$00,$00,$20,$60,$c0,$08,$04,$70,$08,$f8,$80,$71,$80,$00
 dc.b $20,$a9,$00,$00,$09,$fd,$00,$00,$3f,$ff,$c0,$10,$08,$88,$09,$fc,$80,$88,$40,$00
 dc.b $71,$00,$00,$00,$1c,$71,$00,$00,$00,$7f,$c0,$00,$09,$04,$04,$01,$01,$04,$40,$00
 dc.b $22,$00,$00,$00,$08,$71,$00,$00,$00,$00,$00,$00,$11,$14,$03,$06,$01,$44,$20,$00
 dc.b $07,$80,$00,$00,$00,$71,$00,$00,$3a,$11,$a8,$1c,$12,$32,$00,$f8,$02,$62,$20,$00
 dc.b $00,$00,$00,$00,$00,$01,$00,$00,$22,$2a,$28,$10,$12,$72,$00,$00,$02,$72,$20,$00
 dc.b $00,$00,$00,$00,$00,$01,$00,$00,$32,$39,$38,$1c,$12,$f2,$00,$00,$02,$7a,$20,$00
 dc.b $01,$00,$00,$00,$00,$01,$00,$00,$22,$28,$a8,$08,$12,$72,$00,$00,$02,$72,$20,$00
 dc.b $03,$80,$00,$00,$41,$01,$00,$00,$23,$ab,$28,$10,$12,$32,$00,$f8,$02,$62,$20,$00
 dc.b $27,$c0,$00,$20,$41,$01,$00,$00,$00,$00,$00,$00,$11,$14,$03,$06,$01,$44,$20,$00
 dc.b $77,$c0,$00,$73,$59,$8d,$00,$00,$01,$ff,$ff,$80,$09,$04,$04,$01,$01,$04,$40,$00
 dc.b $23,$80,$00,$25,$55,$55,$00,$00,$06,$00,$00,$60,$08,$88,$09,$fc,$80,$88,$40,$00
 dc.b $01,$00,$00,$03,$59,$4d,$00,$00,$08,$00,$00,$10,$04,$70,$08,$f8,$80,$71,$80,$00
 dc.b $00,$00,$00,$00,$10,$01,$00,$00,$10,$00,$00,$08,$03,$00,$08,$70,$80,$02,$00,$00
 dc.b $00,$00,$00,$00,$10,$01,$00,$00,$20,$00,$00,$04,$00,$e0,$04,$21,$00,$1c,$00,$00
 dc.b $00,$00,$00,$00,$00,$01,$00,$00,$20,$00,$00,$04,$00,$1c,$03,$06,$00,$e0,$00,$00
 dc.b $03,$ff,$ff,$ff,$ff,$81,$00,$00,$40,$8e,$71,$c2,$00,$03,$80,$f8,$07,$00,$00,$00
 dc.b $0f,$ff,$ff,$ff,$ff,$e1,$00,$00,$41,$49,$4a,$22,$00,$00,$70,$00,$38,$00,$00,$00
 dc.b $1f,$ff,$ff,$ff,$ff,$f1,$00,$00,$41,$49,$4a,$02,$00,$00,$0f,$ff,$c0,$00,$00,$00
 dc.b $3f,$ff,$a8,$af,$ff,$f9,$00,$00,$42,$2e,$71,$c2,$00,$00,$00,$00,$10,$10,$0d,$1c
 dc.b $7f,$ff,$ab,$af,$ff,$fd,$00,$00,$43,$e8,$40,$22,$00,$00,$00,$00,$28,$30,$11,$14
 dc.b $7f,$ff,$99,$df,$ff,$fd,$00,$00,$42,$28,$40,$22,$00,$00,$00,$00,$03,$50,$11,$18
 dc.b $7f,$ff,$ab,$df,$ff,$fd,$00,$00,$42,$28,$42,$22,$00,$00,$00,$00,$00,$10,$11,$14
 dc.b $3f,$ff,$a8,$df,$ff,$f9,$00,$00,$42,$28,$41,$c2,$00,$00,$00,$00,$00,$10,$0d,$d4
 dc.b $1f,$ff,$ff,$ff,$ff,$f1,$00,$00,$20,$00,$00,$04,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $0f,$ff,$ff,$ff,$ff,$e1,$00,$00,$20,$00,$00,$04,$00,$00,$00,$00,$20,$60,$0d,$1c
 dc.b $03,$ff,$ff,$ff,$ff,$81,$00,$00,$10,$00,$00,$08,$00,$00,$00,$00,$24,$a0,$11,$14
 dc.b $00,$00,$00,$00,$00,$01,$00,$00,$08,$00,$00,$10,$00,$00,$00,$00,$2a,$60,$11,$18
 dc.b $ff,$ff,$ff,$ff,$ff,$ff,$00,$00,$06,$00,$00,$60,$00,$00,$00,$00,$2a,$20,$11,$14
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$01,$ff,$ff,$80,$00,$00,$00,$00,$24,$c0,$0d,$d4
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $33,$74,$40,$0a,$01,$00,$02,$40,$02,$00,$00,$60,$05,$13,$02,$00,$03,$ff,$ff,$c0
 dc.b $44,$26,$c0,$14,$01,$80,$07,$e0,$00,$00,$00,$90,$05,$94,$06,$00,$1c,$00,$00,$38
 dc.b $42,$25,$40,$00,$01,$c0,$02,$40,$02,$00,$01,$e0,$05,$52,$0f,$e0,$20,$00,$00,$04
 dc.b $41,$24,$40,$18,$01,$80,$07,$e0,$02,$00,$01,$00,$05,$31,$06,$00,$43,$47,$99,$c2
 dc.b $36,$24,$40,$14,$01,$00,$02,$40,$01,$00,$00,$c0,$05,$16,$02,$00,$44,$44,$25,$22
 dc.b $00,$00,$00,$14,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$44,$44,$25,$22
 dc.b $00,$00,$00,$00,$00,$00,$01,$80,$00,$00,$00,$00,$00,$00,$00,$00,$44,$47,$3d,$c2
 dc.b $12,$22,$ba,$2e,$00,$00,$02,$40,$02,$80,$32,$70,$06,$74,$02,$00,$44,$44,$25,$42
 dc.b $35,$52,$ab,$68,$00,$00,$00,$80,$05,$40,$45,$20,$05,$44,$06,$00,$44,$44,$25,$22
 dc.b $55,$03,$aa,$ac,$00,$00,$00,$80,$05,$40,$47,$20,$05,$64,$0f,$e0,$43,$77,$a5,$22
 dc.b $15,$02,$aa,$28,$00,$00,$00,$00,$02,$80,$45,$20,$05,$44,$06,$00,$20,$00,$00,$04
 dc.b $12,$02,$ba,$2e,$01,$e0,$00,$80,$00,$00,$35,$20,$06,$77,$02,$00,$1c,$00,$00,$38
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$03,$ff,$ff,$c0
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $01,$ff,$ff,$80,$01,$ff,$ff,$80,$01,$ff,$ff,$80,$01,$ff,$ff,$80,$00,$00,$02,$06
 dc.b $06,$00,$00,$60,$06,$00,$00,$60,$06,$00,$00,$60,$06,$00,$00,$60,$00,$00,$02,$4a
 dc.b $08,$00,$00,$10,$08,$00,$00,$10,$08,$00,$00,$10,$08,$00,$00,$10,$0f,$80,$02,$a6
 dc.b $10,$00,$00,$08,$10,$00,$00,$08,$10,$00,$00,$08,$10,$00,$00,$08,$05,$00,$2a,$a2
 dc.b $20,$00,$00,$04,$20,$00,$00,$04,$20,$00,$00,$04,$20,$00,$00,$04,$05,$00,$12,$4c
 dc.b $20,$00,$00,$04,$20,$00,$00,$04,$20,$00,$00,$04,$20,$00,$00,$04,$00,$00,$28,$00
 dc.b $44,$44,$45,$e2,$44,$44,$71,$e2,$4c,$9c,$91,$12,$40,$20,$00,$02,$00,$00,$00,$00
 dc.b $44,$4a,$6d,$02,$46,$ca,$49,$02,$49,$49,$52,$a2,$40,$60,$00,$02,$02,$00,$14,$3c
 dc.b $44,$51,$6d,$02,$46,$d1,$45,$02,$49,$49,$52,$a2,$40,$e0,$00,$02,$05,$00,$08,$20
 dc.b $47,$d1,$55,$c2,$45,$51,$45,$c2,$49,$c9,$d2,$ba,$41,$ff,$ff,$82,$07,$00,$14,$40
 dc.b $44,$51,$55,$02,$45,$51,$45,$02,$49,$49,$52,$aa,$40,$e0,$00,$02,$05,$00,$01,$40
 dc.b $44,$51,$45,$02,$44,$51,$45,$02,$49,$49,$52,$aa,$40,$60,$00,$02,$02,$00,$00,$80
 dc.b $44,$4a,$45,$02,$44,$4a,$49,$02,$4d,$49,$59,$12,$40,$20,$00,$02,$00,$00,$00,$00
 dc.b $44,$44,$45,$e2,$44,$44,$71,$e2,$40,$00,$00,$02,$40,$00,$00,$02,$03,$ff,$ff,$c0
 dc.b $20,$00,$00,$04,$20,$00,$00,$04,$20,$00,$00,$04,$20,$00,$00,$04,$1c,$00,$00,$38
 dc.b $20,$00,$00,$04,$20,$00,$00,$04,$20,$00,$00,$04,$20,$00,$00,$04,$20,$01,$00,$04
 dc.b $10,$00,$00,$08,$10,$00,$00,$08,$10,$00,$00,$08,$10,$00,$00,$08,$40,$02,$80,$02
 dc.b $08,$00,$00,$10,$08,$00,$00,$10,$08,$00,$00,$10,$08,$00,$00,$10,$40,$04,$40,$02
 dc.b $06,$00,$00,$60,$06,$00,$00,$60,$06,$00,$00,$60,$06,$00,$00,$60,$40,$00,$00,$02
 dc.b $01,$ff,$ff,$80,$01,$ff,$ff,$80,$01,$ff,$ff,$80,$01,$ff,$ff,$80,$20,$00,$00,$04
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$1c,$00,$00,$38
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$03,$ff,$ff,$c0
accenttype89: dc.b 0 ;type of the selected accent
txt_inv89: dc.b '^',173,'1',0
txt_10exp89: dc.b '10^(',0
txt_square89: dc.b '^2',0
txt_cube89: dc.b '^3',0
txt_xroot89: dc.b 'x\root(',0
txt_xlog89: dc.b 'x\logy(',0
txt_sigma89: dc.b 142,'(',0
 dc.b $08 ;tokenized expressions for localization support
abstag89: dc.b $4b
 dc.b $08
logtag89: dc.b $54
 dc.b $09,$08
ncrtag89: dc.b $a7
 dc.b $09,$08
nprtag89: dc.b $a8
 dc.b $e5,$01,$01,$1f
ans1tag89: dc.b $bc
funcbuffer89: ds.b 15
endevent89:

 EVEN ;avoid silly alignment problems
      ;("Address Error" etc.)

newevent89t: ;event hook for TI-89 Titanium AMS >=3.10
 dc.b 'evHkXtraKeys' ;signature "evHk" + program name
                     ;(for event hook uninstaller)
oldevent89t: dc.l 0 ;placeholder for old event hook
                    ;0 if none
                    ;placed here for easier and
                    ;program- and version-independent
                    ;uninstalling
 movem.l a0-a6/d0-d7,-(a7) ;save all registers
 move.l 64(a7),a2 ;a2=event structure address (a2 for TEOS)
 cmp.w #$700,(a2) ;check if CM_IDLE or CM_BLINK
 beq idle89t
 cmp.w #$740,(a2)
 bne notidle89t
idle89t:
 lea.l statusflags89t(PC),a0 ;if yes, save the status flags
 move.w (a0),2(a0)
 move.w 6(a2),(a0)
notidle89t:
 cmp.w #$710,(a2) ;check if CM_KEYPRESS
 bne notkeypress89t ;if not, do nothing
 move.w 10(a2),d5 ;d5 = keycode
 move.b accenttype89t(PC),d1 ;d1 = accent type
 tst.b d1 ;check if there is an accent
 beq noaccent89t ;if not, skip
 cmp.w #'a',d5 ;check if a
 bne notminusa89t
 cmp.b #1,d1 ;check if acute accent
 bne minusanotacute89t
 move.w #225,10(a2) ;change key code to ""
 bra endaccent89t
minusanotacute89t:
 cmp.b #2,d1 ;check if grave accent
 bne minusanotgrave89t
 move.w #224,10(a2) ;change key code to ""
 bra endaccent89t
minusanotgrave89t:
 cmp.b #3,d1 ;check if circumflex accent
 bne minusanotcircumflex89t
 move.w #226,10(a2) ;change key code to ""
 bra endaccent89t
minusanotcircumflex89t:
 cmp.b #4,d1 ;check if trema
 bne minusanottrema89t
 move.w #228,10(a2) ;change key code to ""
 bra endaccent89t
minusanottrema89t:
 move.w #227,10(a2) ;change key code to ""
 bra endaccent89t
notminusa89t:
 cmp.w #'e',d5 ;check if e
 bne notminuse89t
 cmp.b #1,d1 ;check if acute accent
 bne minusenotacute89t
 move.w #233,10(a2) ;change key code to ""
 bra endaccent89t
minusenotacute89t:
 cmp.b #2,d1 ;check if grave accent
 bne minusenotgrave89t
 move.w #232,10(a2) ;change key code to ""
 bra endaccent89t
minusenotgrave89t:
 cmp.b #3,d1 ;check if circumflex accent
 bne minusenotcircumflex89t
 move.w #234,10(a2) ;change key code to ""
 bra endaccent89t
minusenotcircumflex89t:
 cmp.b #4,d1 ;check if trema
 bne invalidaccent89t
 move.w #235,10(a2) ;change key code to ""
 bra endaccent89t
notminuse89t:
 cmp.w #'i',d5 ;check if i
 bne notminusi89t
 cmp.b #1,d1 ;check if acute accent
 bne minusinotacute89t
 move.w #237,10(a2) ;change key code to ""
 bra endaccent89t
minusinotacute89t:
 cmp.b #2,d1 ;check if grave accent
 bne minusinotgrave89t
 move.w #236,10(a2) ;change key code to ""
 bra endaccent89t
minusinotgrave89t:
 cmp.b #3,d1 ;check if circumflex accent
 bne minusinotcircumflex89t
 move.w #238,10(a2) ;change key code to ""
 bra endaccent89t
minusinotcircumflex89t:
 cmp.b #4,d1 ;check if trema
 bne invalidaccent89t
 move.w #239,10(a2) ;change key code to ""
 bra endaccent89t
notminusi89t:
 cmp.w #'o',d5 ;check if o
 bne notminuso89t
 cmp.b #1,d1 ;check if acute accent
 bne minusonotacute89t
 move.w #243,10(a2) ;change key code to ""
 bra endaccent89t
minusonotacute89t:
 cmp.b #2,d1 ;check if grave accent
 bne minusonotgrave89t
 move.w #242,10(a2) ;change key code to ""
 bra endaccent89t
minusonotgrave89t:
 cmp.b #3,d1 ;check if circumflex accent
 bne minusonotcircumflex89t
 move.w #244,10(a2) ;change key code to ""
 bra endaccent89t
minusonotcircumflex89t:
 cmp.b #4,d1 ;check if trema
 bne minusonottrema89t
 move.w #246,10(a2) ;change key code to ""
 bra endaccent89t
minusonottrema89t:
 move.w #245,10(a2) ;change key code to ""
 bra endaccent89t
notminuso89t:
 cmp.w #'u',d5 ;check if u
 bne notminusu89t
 cmp.b #1,d1 ;check if acute accent
 bne minusunotacute89t
 move.w #250,10(a2) ;change key code to ""
 bra endaccent89t
minusunotacute89t:
 cmp.b #2,d1 ;check if grave accent
 bne minusunotgrave89t
 move.w #249,10(a2) ;change key code to ""
 bra endaccent89t
minusunotgrave89t:
 cmp.b #3,d1 ;check if circumflex accent
 bne minusunotcircumflex89t
 move.w #251,10(a2) ;change key code to ""
 bra endaccent89t
minusunotcircumflex89t:
 cmp.b #4,d1 ;check if trema
 bne invalidaccent89t
 move.w #252,10(a2) ;change key code to ""
 bra endaccent89t
notminusu89t:
 cmp.w #'y',d5 ;check if y
 bne notminusy89t
 cmp.b #1,d1 ;check if acute accent
 bne minusynotacute89t
 move.w #253,10(a2) ;change key code to ""
 bra endaccent89t
minusynotacute89t:
 cmp.b #4,d1 ;check if trema
 bne invalidaccent89t
 move.w #255,10(a2) ;change key code to ""
 bra endaccent89t
notminusy89t:
 cmp.w #'n',d5 ;check if n
 bne notminusn89t
 cmp.b #5,d1 ;check if tilde
 bne invalidaccent89t
 move.w #241,10(a2) ;change key code to ""
 bra endaccent89t  
notminusn89t:
 cmp.w #'A',d5 ;check if A
 bne notcapsa89t
 cmp.b #1,d1 ;check if acute accent
 bne capsanotacute89t
 move.w #193,10(a2) ;change key code to ""
 bra endaccent89t
capsanotacute89t:
 cmp.b #2,d1 ;check if grave accent
 bne capsanotgrave89t
 move.w #192,10(a2) ;change key code to ""
 bra endaccent89t
capsanotgrave89t:
 cmp.b #3,d1 ;check if circumflex accent
 bne capsanotcircumflex89t
 move.w #194,10(a2) ;change key code to ""
 bra endaccent89t
capsanotcircumflex89t:
 cmp.b #4,d1 ;check if trema
 bne capsanottrema89t
 move.w #196,10(a2) ;change key code to ""
 bra endaccent89t
capsanottrema89t:
 move.w #195,10(a2) ;change key code to ""
 bra endaccent89t
notcapsa89t:
 cmp.w #'E',d5 ;check if E
 bne notcapse89t
 cmp.b #1,d1 ;check if acute accent
 bne capsenotacute89t
 move.w #201,10(a2) ;change key code to ""
 bra endaccent89t
capsenotacute89t:
 cmp.b #2,d1 ;check if grave accent
 bne capsenotgrave89t
 move.w #200,10(a2) ;change key code to ""
 bra endaccent89t
capsenotgrave89t:
 cmp.b #3,d1 ;check if circumflex accent
 bne capsenotcircumflex89t
 move.w #202,10(a2) ;change key code to ""
 bra endaccent89t
capsenotcircumflex89t:
 cmp.b #4,d1 ;check if trema
 bne invalidaccent89t
 move.w #203,10(a2) ;change key code to ""
 bra endaccent89t
notcapse89t:
 cmp.w #'I',d5 ;check if I
 bne notcapsi89t
 cmp.b #1,d1 ;check if acute accent
 bne capsinotacute89t
 move.w #205,10(a2) ;change key code to ""
 bra endaccent89t
capsinotacute89t:
 cmp.b #2,d1 ;check if grave accent
 bne capsinotgrave89t
 move.w #204,10(a2) ;change key code to ""
 bra endaccent89t
capsinotgrave89t:
 cmp.b #3,d1 ;check if circumflex accent
 bne capsinotcircumflex89t
 move.w #206,10(a2) ;change key code to ""
 bra endaccent89t
capsinotcircumflex89t:
 cmp.b #4,d1 ;check if trema
 bne invalidaccent89t
 move.w #207,10(a2) ;change key code to ""
 bra endaccent89t
notcapsi89t:
 cmp.w #'O',d5 ;check if O
 bne notcapso89t
 cmp.b #1,d1 ;check if acute accent
 bne capsonotacute89t
 move.w #211,10(a2) ;change key code to ""
 bra endaccent89t
capsonotacute89t:
 cmp.b #2,d1 ;check if grave accent
 bne capsonotgrave89t
 move.w #210,10(a2) ;change key code to ""
 bra endaccent89t
capsonotgrave89t:
 cmp.b #3,d1 ;check if circumflex accent
 bne capsonotcircumflex89t
 move.w #212,10(a2) ;change key code to ""
 bra endaccent89t
capsonotcircumflex89t:
 cmp.b #4,d1 ;check if trema
 bne capsonottrema89t
 move.w #214,10(a2) ;change key code to ""
 bra endaccent89t
capsonottrema89t:
 move.w #213,10(a2) ;change key code to ""
 bra endaccent89t
notcapso89t:
 cmp.w #'U',d5 ;check if U
 bne notcapsu89t
 cmp.b #1,d1 ;check if acute accent
 bne capsunotacute89t
 move.w #218,10(a2) ;change key code to ""
 bra endaccent89t
capsunotacute89t:
 cmp.b #2,d1 ;check if grave accent
 bne capsunotgrave89t
 move.w #217,10(a2) ;change key code to ""
 bra endaccent89t
capsunotgrave89t:
 cmp.b #3,d1 ;check if circumflex accent
 bne capsunotcircumflex89t
 move.w #219,10(a2) ;change key code to ""
 bra endaccent89t
capsunotcircumflex89t:
 cmp.b #4,d1 ;check if trema
 bne invalidaccent89t
 move.w #220,10(a2) ;change key code to ""
 bra endaccent89t
notcapsu89t:
 cmp.w #'Y',d5 ;check if Y
 bne notcapsy89t
 cmp.b #1,d1 ;check if acute accent
 bne invalidaccent89t
 move.w #221,10(a2) ;change key code to ""
 bra endaccent89t
notcapsy89t:
 cmp.w #'N',d5 ;check if N
 bne notcapsn89t
 cmp.b #5,d1 ;check if tilde
 bne invalidaccent89t
 move.w #209,10(a2) ;change key code to ""
 bra endaccent89t  
notcapsn89t:
invalidaccent89t:
 move.w #$700,(a2) ;change event to CM_IDLE
endaccent89t:
 lea.l accenttype89t(PC),a0
 clr.b (a0) ;delete accent
 bra notkeypress89t ;do nothing more
noaccent89t:
 ROM_CALL2 FirstWindow
 move.l (a4),a4
 cmp.l catalog89t(PC),a4 ;check if the catalog is active
 beq notkeypress89t ;if yes, don't interfere with it
;"rowread" routine
 move.w #$700,-(a7)
 dc.w $F800+OSSetSR ;disable interrupts
 move.w #$fe,$600018 ;read the keyboard directly to get the
 nop                 ;info TI's event stucture doesn't give
 nop                 ;out (The key modifiers are not given
 nop                 ;if we need them, only if we don't
 nop                 ;need them. Don't ask me why.)
 nop
 nop
 nop
 nop
 nop
 nop
 nop ;The return value is automatically put in $60001b by
 nop ;the hardware.
 move.b $60001b,d3 ;save the result of rowread to d3
 clr.w (a7)
 dc.w $F800+OSSetSR ;reenable interrupts
 addq.l #2,a7
 move.w statusflags289t(PC),d1 ;d1 = status flags
 move.w tidsktop89t(PC),d0 ;d0 = AppID of TIDSKTOP if AMS >=3.01, 0 otherwise
 ROM_CALL2 EV_currentApp
 cmp.w (a4),d0 ;check if the current app is TIDSKTOP
 bne notidsktop89t
 bclr.l #5,d1 ;ignore alpha-lock if in TIDSKTOP (to make F-keys work)
notidsktop89t:
 cmp.w #$107,d5 ;check if CLEAR
 bne notclear89t
 btst.l #0,d1 ;check if sequential 2nd+CLEAR
 bne clear2nd89t
 btst.b #4,d3 ;check if simultaneous 2nd+CLEAR
 bne notclear89t
clear2nd89t:
 move.w #$723,(a2) ;change event to CM_STRING
 move.l window89t(PC),a3 ;check if home screen is active
 btst.b #7,(a3)
 beq simpleinv89t
 move.l params89t(PC),a3
 btst.b #1,16(a3) ;if yes, check if cursor is in entry line
 beq simpleinv89t
 tst.w (a3) ;if yes, check if ans(1) should be added
 beq ansinv89t
 btst.b #5,17(a3)
 beq simpleinv89t
 tst.w 6(a3)
 bne notbeginning189t
 move.w 2(a3),d2
 cmp.w (a3),d2
 bne simpleinv89t
 bra ansinv89t
notbeginning189t:
 tst.w 2(a3)
 bne simpleinv89t
 move.w 6(a3),d2
 cmp.w (a3),d2
 bne simpleinv89t
ansinv89t:
 pea.l 56 ;convert ans(1) to local string
 dc.w $F800+XR_stringPtr
 addq.l #4,a7
 lea.l funcbuffer89t(PC),a1
 move.l a1,a3
ansinvnext89t: ;add ^-1 to ans(1)
 move.b (a0),(a1)+
 cmp.b #')',(a0)+
 bne ansinvnext89t
 move.b #'^',(a1)+
 move.b #173,(a1)+
 move.b #'1',(a1)+
 clr.b (a1)
 move.l a3,8(a2)
 bra notkeypress89t ;do nothing more
simpleinv89t:
 lea.l txt_inv89t(PC),a0 ;insert ^-1
 move.l a0,8(a2)
 bra notkeypress89t ;do nothing more
notclear89t:
 cmp.w #$115,d5 ;check if HOME
 bne nothome89t
 btst.l #2,d1 ;check if sequential DIAMOND+HOME
 bne homediam89t
 btst.b #6,d3 ;check if simultaneous DIAMOND+HOME
 bne nothomed89t
homediam89t:
 move.w #$723,(a2) ;change event to CM_STRING
 lea.l txt_10exp89t(PC),a0 ;insert 10^(
 move.l a0,8(a2)
 bra notkeypress89t ;do nothing more
nothomed89t:
 btst.l #1,d1 ;check if sequential SHIFT+HOME
 bne homeshift89t
 btst.l #4,d1 ;check if CAPS lock+HOME
 bne homeshift89t
 btst.b #5,d3 ;check if simultaneous SHIFT+HOME
 bne nothome89t
homeshift89t:
 lea.l accenttype89t(PC),a0
 move.b #5,(a0) ;tilde
 move.w #$700,(a2) ;change event to CM_IDLE
 bra notkeypress89t ;do nothing more
nothome89t:
 cmp.w #$4107,d5 ;check if DIAMOND+CLEAR
 bne notdiamclear89t
 move.b classicmode89t(PC),d0
 bne diamclearclassic89t
 move.l window89t(PC),a3 ;check if home screen is active
 btst.b #7,(a3)
 beq simpletoln89t
 move.l params89t(PC),a3
 btst.b #1,16(a3) ;if yes, check if cursor is in entry line
 beq simpletoln89t
 tst.w (a3) ;if yes, check if ans(1) should be added
 beq anstoln89t
 btst.b #5,17(a3)
 beq simpletoln89t
 tst.w 6(a3)
 bne notbeginningtoln89t
 move.w 2(a3),d2
 cmp.w (a3),d2
 bne simpletoln89t
 bra anstoln89t
notbeginningtoln89t:
 tst.w 2(a3)
 bne simpletoln89t
 move.w 6(a3),d2
 cmp.w (a3),d2
 bne simpletoln89t
anstoln89t:
 pea.l 56 ;convert ans(1) to local string
 dc.w $F800+XR_stringPtr
 move.l a0,a4
 pea.l 1810 ;convert >ln to local string
 dc.w $F800+XR_stringPtr
 addq.l #8,a7
 lea.l funcbuffer89t(PC),a1
 move.l a1,a3
anstolnnext89t: ;copy ans(1)
 move.b (a4),(a1)+
 cmp.b #')',(a4)+
 bne anstolnnext89t
anstolnnext289t: ;add >ln to ans(1)
 move.b (a0),(a1)+
 tst.b (a0)+
 bne anstolnnext289t
 move.l a3,a0
 bra diamclearmodern89t
simpletoln89t:
 pea.l 1810 ;convert >ln to local string
 dc.w $F800+XR_stringPtr
 addq.l #4,a7
 bra diamclearmodern89t
diamclearclassic89t:
 pea.l 539 ;convert log( to local string
 dc.w $F800+XR_stringPtr
 addq.l #4,a7
diamclearmodern89t:
 lea.l event_string89t(PC),a3 ;insert the address of the log( string into the
 move.l a0,(a3)               ;placeholder in the event structure
 pea.l event89t(PC)
 move.w #-2,-(a7)
 dc.w $F800+EV_sendEvent ;send the CM_STRING event to the current application
 addq.l #6,a7 ;We have to send an additional event because we have to keep the
              ;self-test key working.
 bra notkeypress89t ;do nothing more
notdiamclear89t:
 cmp.w #16439,d5 ;check if DIAMOND+7
 bne notdiam789t
 move.b classicmode89t(PC),d0
 beq notkeypress89t ;only in classic mode
 moveq #'7',d0
 bra runkbdprgm89t
notdiam789t:
 cmp.w #16440,d5 ;check if DIAMOND+8
 bne notdiam889t
 moveq #'8',d0
runkbdprgm89t:
 move.w #$700,(a2) ;change event to CM_IDLE
 lea kbdprgmno89t(PC),a0
 move.b d0,(a0)
 clr.w -(a7)
 lea -60(a7),a7
 pea.l (a7)
 dc.w $F800+ER_catch
 addq.l #4,a7
 tst.w d0
 bne runkbdprgmerror89t
 pea.l endkbdprgmcall89t-kbdprgmcall89t
 dc.w $F800+HeapAllocThrow
 move.w d0,64(a7)
 clr.l (a7)
 move.w d0,(a7)
 move.w d0,-(a7)
 dc.w $F800+HLock
 pea.l endkbdprgmcall89t-kbdprgmcall89t
 pea.l kbdprgmcall89t(PC)
 pea.l (a0)
 dc.w $F800+memcpy
 lea.l 14(a7),a7
 dc.w $F800+NG_execute
 addq.l #4,a7
 dc.w $F800+ER_success
 lea.l 60(a7),a7
 dc.w $F800+HeapFree
 addq.l #2,a7
 bra notkeypress89t ;do nothing more
runkbdprgmerror89t:
 move.w d0,d4 ;save the error number
 lea.l 60(a7),a7
 tst.w (a7)
 beq runkbdprgmnofree89t
 dc.w $F800+HeapFree
runkbdprgmnofree89t:
 move.w d4,(a7) ;rethrow the error
 dc.w $F800+ER_throwVar
notdiam889t:
 cmp.w #16441,d5 ;check if DIAMOND+9
 bne notdiam989t
 move.b classicmode89t(PC),d0
 beq notkeypress89t ;only in classic mode
 moveq #'9',d0
 bra runkbdprgm89t
notdiam989t:
 cmp.w #$10c,d5 ;check if F1
 bne notf189t
 btst.l #1,d1 ;check if sequential SHIFT+F1
 bne f1shift89t
 btst.l #4,d1 ;check if CAPS lock+F1
 bne f1shift89t
 btst.b #5,d3 ;check if simultaneous SHIFT+F1
 bne notf1s89t
f1shift89t:
 move.l #3000,-(a7)
 dc.w $F800+HeapAllocPtr
 move.l a0,d4 ;save the address to d4
 tst.l d4
 beq f1shiftnomem89t ;if NULL pointer, don't display key map
 move.l #$4c00,-(a7)
 move.l d4,-(a7)
 dc.w $F800+memcpy ;save the screen
 addq.l #8,a7
 lea.l classicmode89t(PC),a3
 move.b (a3),d5
keymapredraw89t:
 move.w #4,-(a7)
 pea.l keymapclip89t(PC)
 pea.l keymap89t(PC)
 clr.l -(a7)
 dc.w $F800+BitmapPut ;display the key map
 lea.l 14(a7),a7
 tst.b d5
 beq keymapnotclassic89t
 move.w #4,-(a7)
 pea.l keymapclip89t(PC)
 pea.l classickeymap89t(PC)
 pea.l 58
 dc.w $F800+BitmapPut ;display the key map
 lea.l 14(a7),a7
keymapnotclassic89t:
 dc.w $F800+ngetchx ;wait for a keypress
 cmp.w #338,d0 ;KEY_LEFT
 bne keymapnotleft89t
 st.b d5 ;enable classic mode
keymapnotleft89t:
 cmp.w #344,d0 ;KEY_RIGHT
 bne keymapnotright89t
 clr.b d5 ;disable classic mode
keymapnotright89t:
 cmp.w #264,d0 ;KEY_ESC
 beq keymapcancel89t
 cmp.w #13,d0 ;KEY_ENTER
 bne keymapredraw89t
 move.b d5,(a3)
keymapcancel89t:
 move.l d4,-(a7)
 move.l #$4c00,-(a7)
 dc.w $F800+memcpy ;restore the screen
 addq.l #4,a7
 move.l d4,(a7)
 dc.w $F800+HeapFreePtr
 addq.l #4,a7
f1shiftnomem89t:
 addq.l #4,a7
 move.w #$700,(a2) ;change event to CM_IDLE
 bra notkeypress89t ;do nothing more
notf1s89t:
 btst.l #3,d1 ;check if sequential alpha+F1
 bne f1alpha89t
 btst.l #5,d1 ;check if alpha lock+F1
 bne f1alpha89t
 btst.b #7,d3 ;check if simultaneous alpha+F1
 bne notf189t
f1alpha89t:
 lea.l accenttype89t(PC),a0
 move.b #1,(a0) ;acute accent
 move.w #$700,(a2) ;change event to CM_IDLE
 bra notkeypress89t ;do nothing more
notf189t:
 cmp.w #$10d,d5 ;check if F2
 bne notf289t
 btst.l #1,d1 ;check if sequential SHIFT+F2
 bne f2shift89t
 btst.l #4,d1 ;check if CAPS lock+F2
 bne f2shift89t
 btst.b #5,d3 ;check if simultaneous SHIFT+F2
 bne notf2s89t
f2shift89t:
 pea.l 31 ;convert abs( to local string
 dc.w $F800+XR_stringPtr
 addq.l #4,a7
 move.w #$723,(a2) ;change event to CM_STRING
 move.l a0,8(a2) ;insert abs(
 bra notkeypress89t ;do nothing more
notf2s89t:
 btst.l #3,d1 ;check if sequential alpha+F2
 bne f2alpha89t
 btst.l #5,d1 ;check if alpha lock+F2
 bne f2alpha89t
 btst.b #7,d3 ;check if simultaneous alpha+F2
 bne notf289t
f2alpha89t:
 lea.l accenttype89t(PC),a0
 move.b #2,(a0) ;grave accent
 move.w #$700,(a2) ;change event to CM_IDLE
 bra notkeypress89t ;do nothing more
notf289t:
 cmp.w #$10e,d5 ;check if F3
 bne notf389t
 btst.l #1,d1 ;check if sequential SHIFT+F3
 bne f3shift89t
 btst.l #4,d1 ;check if CAPS lock+F3
 bne f3shift89t
 btst.b #5,d3 ;check if simultaneous SHIFT+F3
 bne notf3s89t
f3shift89t:
 pea.l 615 ;convert nCr( to local string
 dc.w $F800+XR_stringPtr
 addq.l #4,a7
 move.w #$723,(a2) ;change event to CM_STRING
 move.l a0,8(a2) ;insert nCr(
 bra notkeypress89t ;do nothing more
notf3s89t:
 btst.l #3,d1 ;check if sequential alpha+F3
 bne f3alpha89t
 btst.l #5,d1 ;check if alpha lock+F3
 bne f3alpha89t
 btst.b #7,d3 ;check if simultaneous alpha+F3
 bne notf389t
f3alpha89t:
 lea.l accenttype89t(PC),a0
 move.b #3,(a0) ;circumflex accent
 move.w #$700,(a2) ;change event to CM_IDLE
 bra notkeypress89t ;do nothing more
notf389t:
 cmp.w #$10f,d5 ;check if F4
 bne notf489t
 btst.l #0,d1 ;check if sequential 2nd+F4
 bne f42nd89t
 btst.b #4,d3 ;check if simultaneous 2nd+F4
 bne notf4289t
f42nd89t:
 move.w #$723,(a2) ;change event to CM_STRING
 move.l window89t(PC),a3 ;check if home screen is active
 btst.b #7,(a3)
 beq simplesquare89t
 move.l params89t(PC),a3
 btst.b #1,16(a3) ;if yes, check if cursor is in entry line
 beq simplesquare89t
 tst.w (a3) ;if yes, check if ans(1) should be added
 beq anssquare89t
 btst.b #5,17(a3)
 beq simplesquare89t
 tst.w 6(a3)
 bne notbeginning289t
 move.w 2(a3),d2
 cmp.w (a3),d2
 bne simplesquare89t
 bra anssquare89t
notbeginning289t:
 tst.w 2(a3)
 bne simplesquare89t
 move.w 6(a3),d2
 cmp.w (a3),d2
 bne simplesquare89t
anssquare89t:
 pea.l 56 ;convert ans(1) to local string
 dc.w $F800+XR_stringPtr
 addq.l #4,a7
 lea.l funcbuffer89t(PC),a1
 move.l a1,a3
anssquarenext89t: ;add ^2 to ans(1)
 move.b (a0),(a1)+
 cmp.b #')',(a0)+
 bne anssquarenext89t
 move.b #'^',(a1)+
 move.b #'2',(a1)+
 clr.b (a1)
 move.l a3,8(a2)
 bra notkeypress89t ;do nothing more
simplesquare89t:
 lea.l txt_square89t(PC),a0 ;insert ^2
 move.l a0,8(a2)
 bra notkeypress89t ;do nothing more
notf4289t:
 btst.l #1,d1 ;check if sequential SHIFT+F4
 bne f4shift89t
 btst.l #4,d1 ;check if CAPS lock+F4
 bne f4shift89t
 btst.b #5,d3 ;check if simultaneous SHIFT+F4
 bne notf4s89t
f4shift89t:
 pea.l 641 ;convert nPr( to local string
 dc.w $F800+XR_stringPtr
 addq.l #4,a7
 move.w #$723,(a2) ;change event to CM_STRING
 move.l a0,8(a2) ;insert nPr(
 bra notkeypress89t ;do nothing more
notf4s89t:
 btst.l #3,d1 ;check if sequential alpha+F4
 bne f4alpha89t
 btst.l #5,d1 ;check if alpha lock+F4
 bne f4alpha89t
 btst.b #7,d3 ;check if simultaneous alpha+F4
 bne notf489t
f4alpha89t:
 lea.l accenttype89t(PC),a0
 move.b #4,(a0) ;trema or german Umlaut
 move.w #$700,(a2) ;change event to CM_IDLE
 bra notkeypress89t ;do nothing more
notf489t:
 cmp.w #$110,d5 ;check if F5
 bne notf589t
 btst.l #0,d1 ;check if sequential 2nd+F5
 bne f52nd89t
 btst.b #4,d3 ;check if simultaneous 2nd+F5
 bne notf5289t
f52nd89t:
 move.w #$723,(a2) ;change event to CM_STRING
 move.l window89t(PC),a3 ;check if home screen is active
 btst.b #7,(a3)
 beq simplecube89t
 move.l params89t(PC),a3
 btst.b #1,16(a3) ;if yes, check if cursor is in entry line
 beq simplecube89t
 tst.w (a3) ;if yes, check if ans(1) should be added
 beq anscube89t
 btst.b #5,17(a3)
 beq simplecube89t
 tst.w 6(a3)
 bne notbeginning389t
 move.w 2(a3),d2
 cmp.w (a3),d2
 bne simplecube89t
 bra anscube89t
notbeginning389t:
 tst.w 2(a3)
 bne simplecube89t
 move.w 6(a3),d2
 cmp.w (a3),d2
 bne simplecube89t
anscube89t:
 pea.l 56 ;convert ans(1) to local string
 dc.w $F800+XR_stringPtr
 addq.l #4,a7
 lea.l funcbuffer89t(PC),a1
 move.l a1,a3
anscubenext89t: ;add ^3 to ans(1)
 move.b (a0),(a1)+
 cmp.b #')',(a0)+
 bne anscubenext89t
 move.b #'^',(a1)+
 move.b #'3',(a1)+
 clr.b (a1)
 move.l a3,8(a2)
 bra notkeypress89t ;do nothing more
simplecube89t:
 lea.l txt_cube89t(PC),a0 ;insert ^3
 move.l a0,8(a2)
 bra notkeypress89t ;do nothing more
notf5289t:
 btst.l #1,d1 ;check if sequential SHIFT+F5
 bne f5shift89t
 btst.l #4,d1 ;check if CAPS lock+F5
 bne f5shift89t
 btst.b #5,d3 ;check if simultaneous SHIFT+F5
 bne notf5s89t
f5shift89t:
 move.w #$723,(a2) ;change event to CM_STRING
 lea.l txt_sigma89t(PC),a0 ;insert SIGMA(
 move.l a0,8(a2)
 bra notkeypress89t ;do nothing more
notf5s89t:
 btst.l #3,d1 ;check if sequential alpha+F5
 bne f5alpha89t
 btst.l #5,d1 ;check if alpha lock+F5
 bne f5alpha89t
 btst.b #7,d3 ;check if simultaneous alpha+F5
 bne notf589t
f5alpha89t:
 move.w #223,10(a2) ;change key code to german sz
 bra notkeypress89t ;do nothing more
notf589t:
 cmp.w #$5e,d5 ;check if ^
 bne notpower89t
 btst.l #1,d1 ;check if sequential SHIFT+^
 bne powershift89t
 btst.l #4,d1 ;check if CAPS lock+^
 bne powershift89t
 btst.b #5,d3 ;check if simultaneous SHIFT+^
 bne notpowers89t
powershift89t:
 move.w #$723,(a2) ;change event to CM_STRING
 lea.l txt_grad89t(PC),a0 ;insert ^G
 move.l a0,8(a2)
 bra notkeypress89t ;do nothing more
notpowers89t:
 btst.l #3,d1 ;check if sequential alpha+^
 bne poweralpha89t
 btst.l #5,d1 ;check if alpha lock+^
 bne poweralpha89t
 btst.b #7,d3 ;check if simultaneous alpha+^
 bne notpower89t
poweralpha89t:
 move.b classicmode89t(PC),d0
 bne poweralphaclassic89t
 move.w #$723,(a2) ;change event to CM_STRING
 move.l window89t(PC),a3 ;check if home screen is active
 btst.b #7,(a3)
 beq simpletologbase89t
 move.l params89t(PC),a3
 btst.b #1,16(a3) ;if yes, check if cursor is in entry line
 beq simpletologbase89t
 tst.w (a3) ;if yes, check if ans(1) should be added
 beq anstologbase89t
 btst.b #5,17(a3)
 beq simpletologbase89t
 tst.w 6(a3)
 bne notbeginningtologbase89t
 move.w 2(a3),d2
 cmp.w (a3),d2
 bne simpletologbase89t
 bra anstologbase89t
notbeginningtologbase89t:
 tst.w 2(a3)
 bne simpletologbase89t
 move.w 6(a3),d2
 cmp.w (a3),d2
 bne simpletologbase89t
anstologbase89t:
 pea.l 56 ;convert ans(1) to local string
 dc.w $F800+XR_stringPtr
 move.l a0,a4
 pea.l 1816 ;convert >logbase( to local string
 dc.w $F800+XR_stringPtr
 addq.l #8,a7
 lea.l funcbuffer89t(PC),a1
 move.l a1,a3
anstologbasenext89t: ;copy ans(1)
 move.b (a4),(a1)+
 cmp.b #')',(a4)+
 bne anstologbasenext89t
anstologbasenext289t: ;add >logbase( to ans(1)
 move.b (a0),(a1)+
 tst.b (a0)+
 bne anstologbasenext289t
 move.l a3,8(a2) ;insert ans(1)>logbase(
 bra notkeypress89t ;do nothing more
simpletologbase89t:
 pea.l 1816 ;convert >logbase( to local string
 dc.w $F800+XR_stringPtr
 addq.l #4,a7
 move.l a0,8(a2) ;insert >logbase(
 bra notkeypress89t ;do nothing more
poweralphaclassic89t:
 move.w #16441,10(a2) ;change key code to DIAMOND+9
 bra notkeypress89t ;do nothing more
notpower89t:
 cmp.w #$10a,d5 ;check if MODE
 bne notmode89t
 btst.l #1,d1 ;check if sequential SHIFT+MODE
 bne modeshift89t
 btst.l #4,d1 ;check if CAPS lock+MODE
 bne modeshift89t
 btst.b #5,d3 ;check if simultaneous SHIFT+MODE
 bne notmodes89t
modeshift89t:
 move.w #'#',10(a2) ;change key code to "#"
 bra notkeypress89t ;do nothing more
notmodes89t:
 btst.l #3,d1 ;check if sequential alpha+MODE
 bne modealpha89t
 btst.l #5,d1 ;check if alpha lock+MODE
 bne modealpha89t
 btst.b #7,d3 ;check if simultaneous alpha+MODE
 bne notmode89t
modealpha89t:
 move.w #'?',10(a2) ;change key code to "?"
 bra notkeypress89t ;do nothing more
notmode89t:
 cmp.w #$109,d5 ;check if APPS
 bne notapps89t
 btst.l #1,d1 ;check if sequential SHIFT+APPS
 bne appsshift89t
 btst.l #4,d1 ;check if CAPS lock+APPS
 bne appsshift89t
 btst.b #5,d3 ;check if simultaneous SHIFT+APPS
 bne notappss89t
appsshift89t:
 move.w #199,10(a2) ;change key code to C cedilla
 bra notkeypress89t ;do nothing more
notappss89t:
 btst.l #3,d1 ;check if sequential alpha+APPS
 bne appsalpha89t
 btst.l #5,d1 ;check if alpha lock+APPS
 bne appsalpha89t
 btst.b #7,d3 ;check if simultaneous alpha+APPS
 bne notapps89t
appsalpha89t:
 move.w #231,10(a2) ;change key code to c cedilla
 bra notkeypress89t ;do nothing more
notapps89t:
 cmp.w #$116,d5 ;check if CATALOG
 bne notkeypress89t
 btst.l #1,d1 ;check if sequential SHIFT+CATALOG
 bne catalogshift89t
 btst.l #4,d1 ;check if CAPS lock+CATALOG
 bne catalogshift89t
 btst.b #5,d3 ;check if simultaneous SHIFT+CATALOG
 bne notkeypress89t
catalogshift89t:
 move.w #150,10(a2) ;change key code to Napier/Euler e
notkeypress89t:
 move.l oldevent89t(PC),a0 ;a0 = old event hook
 cmp.l #0,a0 ;check if 0 (tst refuses this addressing mode)
 beq nooldevent89t ;if 0 do nothing
 move.l a2,-(a7) ;pass event structure as an argument
 jsr (a0) ;run the old event hook
 addq.l #4,a7
nooldevent89t:
 movem.l (a7)+,a0-a6/d0-d7 ;restore all registers
 rts ;return
 EVEN ;avoid silly alignment problems
      ;("Address Error" etc.)
statusflags89t: dc.w 0 ;placeholder for the status flags
statusflags289t: dc.w 0
params89t: dc.l $6016 ;position of the home screen entry line
                      ;parameters
window89t: dc.l $6071 ;position of the 2nd byte of the home
                      ;screen window flags (containing the
                      ;"active" flag)
catalog89t: dc.l 0 ;position of the catalog window flags
tidsktop89t: dc.w 0 ;AppID of TIDSKTOP
;Those values may be adjusted for different AMS versions.
event89t: ;event structure for EV_sendEvent
 dc.w $723 ;type = CM_STRING
 ds.b 6 ;RunningApp (2), Side (2), StatusFlags (2)
event_string89t:
 ds.b 6 ;pasteText (4), StartType (2)
keymapclip89t: dc.b 0,0,159,99
keymap89t:
 dc.w 100,160
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $39,$81,$5d,$4c,$3b,$80,$00,$80,$39,$00,$00,$60,$11,$00,$00,$c0,$13,$00,$00,$3c
 dc.b $22,$01,$51,$50,$20,$80,$06,$cc,$22,$80,$00,$80,$2a,$80,$00,$a0,$28,$80,$00,$10
 dc.b $33,$01,$98,$88,$30,$80,$0a,$a8,$31,$00,$0c,$8c,$00,$80,$0c,$cc,$03,$00,$00,$08
 dc.b $22,$81,$50,$84,$21,$00,$0a,$a4,$22,$80,$0a,$88,$01,$00,$0a,$88,$00,$80,$00,$10
 dc.b $21,$01,$5c,$98,$22,$00,$06,$cc,$21,$00,$0a,$68,$03,$80,$0a,$88,$03,$00,$00,$3c
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$04,$00,$00,$00,$08,$00,$00,$00,$08,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$08,$00,$00,$00,$04,$00,$00,$00,$14,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $28,$00,$00,$00,$2a,$96,$54,$00,$1b,$13,$28,$00,$3a,$26,$08,$14,$39,$32,$38,$18
 dc.b $2b,$80,$00,$08,$2a,$d5,$54,$0c,$22,$aa,$a8,$08,$12,$28,$48,$00,$12,$aa,$20,$24
 dc.b $10,$00,$00,$14,$2a,$f5,$54,$14,$2b,$3b,$38,$14,$13,$24,$ac,$14,$13,$b2,$30,$28
 dc.b $13,$80,$00,$18,$2a,$b5,$54,$14,$2a,$aa,$28,$14,$12,$a2,$c8,$14,$12,$aa,$20,$24
 dc.b $10,$00,$00,$0c,$14,$96,$28,$0c,$12,$aa,$28,$08,$13,$2c,$6c,$1c,$12,$b3,$b8,$28
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$03,$ff,$ff,$c0
 dc.b $1c,$00,$00,$38,$1c,$00,$00,$38,$1c,$00,$00,$38,$1c,$00,$00,$38,$1c,$00,$00,$38
 dc.b $20,$0e,$10,$04,$20,$0e,$60,$04,$20,$0e,$60,$04,$20,$0e,$50,$04,$20,$0e,$f0,$04
 dc.b $40,$08,$30,$02,$40,$08,$90,$02,$40,$08,$10,$02,$40,$08,$50,$02,$40,$08,$80,$02
 dc.b $40,$08,$50,$02,$40,$08,$10,$02,$40,$08,$60,$02,$40,$08,$90,$02,$40,$08,$e0,$02
 dc.b $40,$0e,$10,$02,$40,$0e,$20,$02,$40,$0e,$10,$02,$40,$0e,$f0,$02,$40,$0e,$10,$02
 dc.b $40,$08,$10,$02,$40,$08,$40,$02,$40,$08,$10,$02,$40,$08,$10,$02,$40,$08,$10,$02
 dc.b $20,$08,$10,$04,$20,$08,$f0,$04,$20,$08,$60,$04,$20,$08,$10,$04,$20,$08,$e0,$04
 dc.b $1c,$00,$00,$38,$1c,$00,$00,$38,$1c,$00,$00,$38,$1c,$00,$00,$38,$1c,$00,$00,$38
 dc.b $03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$03,$ff,$ff,$c0
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$7f,$c0,$00,$00,$00,$0f,$ff,$c0,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$3f,$ff,$c0,$0c,$00,$00,$70,$00,$38,$00,$00,$00
 dc.b $ff,$ff,$ff,$ff,$ff,$ff,$00,$00,$20,$60,$c0,$10,$00,$03,$80,$f8,$07,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$01,$00,$00,$22,$68,$c0,$10,$00,$1c,$03,$06,$00,$e0,$00,$00
 dc.b $00,$00,$80,$00,$00,$21,$00,$00,$27,$fc,$c0,$10,$00,$e0,$04,$21,$00,$1c,$00,$00
 dc.b $03,$39,$80,$00,$00,$71,$00,$00,$22,$68,$c0,$0c,$03,$00,$08,$70,$80,$02,$00,$00
 dc.b $04,$aa,$80,$00,$00,$f9,$00,$00,$20,$60,$c0,$08,$04,$70,$08,$f8,$80,$71,$80,$00
 dc.b $20,$a9,$00,$00,$09,$fd,$00,$00,$3f,$ff,$c0,$10,$08,$88,$09,$fc,$80,$88,$40,$00
 dc.b $71,$00,$00,$00,$1c,$71,$00,$00,$00,$7f,$c0,$00,$09,$04,$04,$01,$01,$04,$40,$00
 dc.b $22,$00,$00,$00,$08,$71,$00,$00,$00,$00,$00,$00,$11,$14,$03,$06,$01,$44,$20,$00
 dc.b $07,$80,$00,$00,$00,$71,$00,$00,$3a,$11,$a8,$1c,$12,$32,$00,$f8,$02,$62,$20,$00
 dc.b $00,$00,$00,$00,$00,$01,$00,$00,$22,$2a,$28,$10,$12,$72,$00,$00,$02,$72,$20,$00
 dc.b $00,$00,$00,$00,$00,$01,$00,$00,$32,$39,$38,$1c,$12,$f2,$00,$00,$02,$7a,$20,$00
 dc.b $01,$00,$00,$00,$00,$01,$00,$00,$22,$28,$a8,$08,$12,$72,$00,$00,$02,$72,$20,$00
 dc.b $03,$80,$00,$00,$41,$01,$00,$00,$23,$ab,$28,$10,$12,$32,$00,$f8,$02,$62,$20,$00
 dc.b $27,$c0,$00,$20,$41,$01,$00,$00,$00,$00,$00,$00,$11,$14,$03,$06,$01,$44,$20,$00
 dc.b $77,$c0,$00,$73,$59,$8d,$00,$00,$01,$ff,$ff,$80,$09,$04,$04,$01,$01,$04,$40,$00
 dc.b $23,$80,$00,$25,$55,$55,$00,$00,$06,$00,$00,$60,$08,$88,$09,$fc,$80,$88,$40,$00
 dc.b $01,$00,$00,$03,$59,$4d,$00,$00,$08,$00,$00,$10,$04,$70,$08,$f8,$80,$71,$80,$00
 dc.b $00,$00,$00,$00,$10,$01,$00,$00,$10,$00,$00,$08,$03,$00,$08,$70,$80,$02,$00,$00
 dc.b $00,$00,$00,$00,$10,$01,$00,$00,$20,$00,$00,$04,$00,$e0,$04,$21,$00,$1c,$00,$00
 dc.b $00,$00,$00,$00,$00,$01,$00,$00,$20,$00,$00,$04,$00,$1c,$03,$06,$00,$e0,$00,$00
 dc.b $03,$ff,$ff,$ff,$ff,$81,$00,$00,$40,$8e,$71,$c2,$00,$03,$80,$f8,$07,$00,$00,$00
 dc.b $0f,$ff,$ff,$ff,$ff,$e1,$00,$00,$41,$49,$4a,$22,$00,$00,$70,$00,$38,$00,$00,$00
 dc.b $1f,$ff,$ff,$ff,$ff,$f1,$00,$00,$41,$49,$4a,$02,$00,$00,$0f,$ff,$c0,$00,$00,$00
 dc.b $3f,$ff,$a8,$af,$ff,$f9,$00,$00,$42,$2e,$71,$c2,$00,$00,$00,$00,$10,$10,$0d,$1c
 dc.b $7f,$ff,$ab,$af,$ff,$fd,$00,$00,$43,$e8,$40,$22,$00,$00,$00,$00,$28,$30,$11,$14
 dc.b $7f,$ff,$99,$df,$ff,$fd,$00,$00,$42,$28,$40,$22,$00,$00,$00,$00,$03,$50,$11,$18
 dc.b $7f,$ff,$ab,$df,$ff,$fd,$00,$00,$42,$28,$42,$22,$00,$00,$00,$00,$00,$10,$11,$14
 dc.b $3f,$ff,$a8,$df,$ff,$f9,$00,$00,$42,$28,$41,$c2,$00,$00,$00,$00,$00,$10,$0d,$d4
 dc.b $1f,$ff,$ff,$ff,$ff,$f1,$00,$00,$20,$00,$00,$04,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $0f,$ff,$ff,$ff,$ff,$e1,$00,$00,$20,$00,$00,$04,$00,$00,$00,$00,$22,$00,$0d,$1c
 dc.b $03,$ff,$ff,$ff,$ff,$81,$00,$00,$10,$00,$00,$08,$00,$00,$00,$00,$32,$00,$11,$14
 dc.b $00,$00,$00,$00,$00,$01,$00,$00,$08,$00,$00,$10,$00,$00,$00,$00,$3a,$c0,$11,$18
 dc.b $ff,$ff,$ff,$ff,$ff,$ff,$00,$00,$06,$00,$00,$60,$00,$00,$00,$00,$32,$a0,$11,$14
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$01,$ff,$ff,$80,$00,$00,$00,$00,$22,$a0,$0d,$d4
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $33,$74,$40,$0a,$01,$00,$02,$40,$02,$00,$00,$60,$05,$13,$02,$00,$03,$ff,$ff,$c0
 dc.b $44,$26,$c0,$14,$01,$80,$07,$e0,$00,$00,$00,$90,$05,$94,$06,$00,$1c,$00,$00,$38
 dc.b $42,$25,$40,$00,$01,$c0,$02,$40,$02,$00,$01,$e0,$05,$52,$0f,$e0,$20,$00,$00,$04
 dc.b $41,$24,$40,$18,$01,$80,$07,$e0,$02,$00,$01,$00,$05,$31,$06,$00,$43,$47,$99,$c2
 dc.b $36,$24,$40,$14,$01,$00,$02,$40,$01,$00,$00,$c0,$05,$16,$02,$00,$44,$44,$25,$22
 dc.b $00,$00,$00,$14,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$44,$44,$25,$22
 dc.b $00,$00,$00,$00,$00,$00,$01,$80,$00,$00,$00,$00,$00,$00,$00,$00,$44,$47,$3d,$c2
 dc.b $12,$22,$ba,$2e,$00,$00,$02,$40,$02,$80,$32,$70,$06,$74,$02,$00,$44,$44,$25,$42
 dc.b $35,$52,$ab,$68,$00,$00,$00,$80,$05,$40,$45,$20,$05,$44,$06,$00,$44,$44,$25,$22
 dc.b $55,$03,$aa,$ac,$00,$00,$00,$80,$05,$40,$47,$20,$05,$64,$0f,$e0,$43,$77,$a5,$22
 dc.b $15,$02,$aa,$28,$00,$00,$00,$00,$02,$80,$45,$20,$05,$44,$06,$00,$20,$00,$00,$04
 dc.b $12,$02,$ba,$2e,$01,$e0,$00,$80,$00,$00,$35,$20,$06,$77,$02,$00,$1c,$00,$00,$38
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$03,$ff,$ff,$c0
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$00,$00,$00,$e0
 dc.b $1c,$00,$00,$38,$1c,$00,$00,$38,$1c,$00,$00,$38,$1c,$00,$00,$38,$00,$00,$01,$00
 dc.b $20,$00,$00,$04,$20,$00,$00,$04,$20,$00,$00,$04,$20,$00,$00,$04,$0f,$80,$01,$60
 dc.b $44,$44,$45,$e2,$44,$44,$71,$e2,$4c,$9c,$91,$12,$40,$20,$00,$02,$05,$00,$00,$c0
 dc.b $44,$4a,$6d,$02,$46,$ca,$49,$02,$49,$49,$52,$a2,$40,$60,$00,$02,$05,$00,$00,$00
 dc.b $44,$51,$6d,$02,$46,$d1,$45,$02,$49,$49,$52,$a2,$40,$e0,$00,$02,$00,$00,$00,$00
 dc.b $47,$d1,$55,$c2,$45,$51,$45,$c2,$49,$c9,$d2,$ba,$41,$ff,$ff,$82,$00,$00,$00,$00
 dc.b $44,$51,$55,$02,$45,$51,$45,$02,$49,$49,$52,$aa,$40,$e0,$00,$02,$02,$02,$20,$68
 dc.b $44,$4a,$45,$02,$44,$4a,$49,$02,$49,$49,$52,$aa,$40,$60,$00,$02,$05,$03,$24,$ac
 dc.b $44,$44,$45,$e2,$44,$44,$71,$e2,$4d,$49,$59,$12,$40,$20,$00,$02,$07,$03,$aa,$6a
 dc.b $20,$00,$00,$04,$20,$00,$00,$04,$20,$00,$00,$04,$20,$00,$00,$04,$05,$03,$2a,$2a
 dc.b $1c,$00,$00,$38,$1c,$00,$00,$38,$1c,$00,$00,$38,$1c,$00,$00,$38,$02,$02,$24,$cc
 dc.b $03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$03,$ff,$ff,$c0
 dc.b $03,$11,$00,$40,$00,$30,$07,$ff,$ff,$ff,$fe,$ff,$ff,$ff,$ff,$ff,$1c,$00,$00,$38
 dc.b $0f,$1b,$00,$40,$00,$2c,$04,$7d,$ff,$ff,$6a,$8f,$ff,$cf,$ff,$fb,$20,$01,$00,$04
 dc.b $3f,$1b,$00,$40,$00,$23,$05,$fd,$ef,$c6,$aa,$bf,$f8,$bf,$ff,$db,$40,$02,$80,$02
 dc.b $7f,$15,$31,$c9,$56,$20,$84,$44,$54,$7e,$a6,$8c,$cf,$bc,$8c,$ab,$40,$04,$40,$02
 dc.b $3f,$15,$4a,$55,$9a,$23,$05,$d5,$cd,$c6,$aa,$bd,$b8,$ba,$ab,$9b,$40,$00,$00,$02
 dc.b $0f,$11,$4a,$59,$12,$2c,$04,$56,$65,$ff,$6a,$89,$cf,$cc,$ac,$cd,$20,$00,$00,$04
 dc.b $03,$11,$31,$8d,$12,$30,$07,$ff,$ff,$ff,$fe,$ff,$ff,$ff,$ff,$ff,$1c,$00,$00,$38
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$03,$ff,$ff,$c0
classickeymap89t:
 dc.w 42,160
 dc.b $0f,$ff,$ff,$ff,$ff,$e1,$00,$00,$20,$00,$00,$04,$00,$00,$00,$00,$20,$60,$0d,$1c
 dc.b $03,$ff,$ff,$ff,$ff,$81,$00,$00,$10,$00,$00,$08,$00,$00,$00,$00,$24,$a0,$11,$14
 dc.b $00,$00,$00,$00,$00,$01,$00,$00,$08,$00,$00,$10,$00,$00,$00,$00,$2a,$60,$11,$18
 dc.b $ff,$ff,$ff,$ff,$ff,$ff,$00,$00,$06,$00,$00,$60,$00,$00,$00,$00,$2a,$20,$11,$14
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$01,$ff,$ff,$80,$00,$00,$00,$00,$24,$c0,$0d,$d4
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $33,$74,$40,$0a,$01,$00,$02,$40,$02,$00,$00,$60,$05,$13,$02,$00,$03,$ff,$ff,$c0
 dc.b $44,$26,$c0,$14,$01,$80,$07,$e0,$00,$00,$00,$90,$05,$94,$06,$00,$1c,$00,$00,$38
 dc.b $42,$25,$40,$00,$01,$c0,$02,$40,$02,$00,$01,$e0,$05,$52,$0f,$e0,$20,$00,$00,$04
 dc.b $41,$24,$40,$18,$01,$80,$07,$e0,$02,$00,$01,$00,$05,$31,$06,$00,$43,$47,$99,$c2
 dc.b $36,$24,$40,$14,$01,$00,$02,$40,$01,$00,$00,$c0,$05,$16,$02,$00,$44,$44,$25,$22
 dc.b $00,$00,$00,$14,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$44,$44,$25,$22
 dc.b $00,$00,$00,$00,$00,$00,$01,$80,$00,$00,$00,$00,$00,$00,$00,$00,$44,$47,$3d,$c2
 dc.b $12,$22,$ba,$2e,$00,$00,$02,$40,$02,$80,$32,$70,$06,$74,$02,$00,$44,$44,$25,$42
 dc.b $35,$52,$ab,$68,$00,$00,$00,$80,$05,$40,$45,$20,$05,$44,$06,$00,$44,$44,$25,$22
 dc.b $55,$03,$aa,$ac,$00,$00,$00,$80,$05,$40,$47,$20,$05,$64,$0f,$e0,$43,$77,$a5,$22
 dc.b $15,$02,$aa,$28,$00,$00,$00,$00,$02,$80,$45,$20,$05,$44,$06,$00,$20,$00,$00,$04
 dc.b $12,$02,$ba,$2e,$01,$e0,$00,$80,$00,$00,$35,$20,$06,$77,$02,$00,$1c,$00,$00,$38
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$03,$ff,$ff,$c0
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$00,$00,$00,$e0
 dc.b $1c,$00,$00,$38,$1c,$00,$00,$38,$1c,$00,$00,$38,$1c,$00,$00,$38,$00,$00,$01,$00
 dc.b $20,$00,$00,$04,$20,$00,$00,$04,$20,$00,$00,$04,$20,$00,$00,$04,$0f,$80,$01,$60
 dc.b $44,$44,$45,$e2,$44,$44,$71,$e2,$4c,$9c,$91,$12,$40,$20,$00,$02,$05,$00,$00,$c0
 dc.b $44,$4a,$6d,$02,$46,$ca,$49,$02,$49,$49,$52,$a2,$40,$60,$00,$02,$05,$00,$00,$00
 dc.b $44,$51,$6d,$02,$46,$d1,$45,$02,$49,$49,$52,$a2,$40,$e0,$00,$02,$00,$00,$00,$00
 dc.b $47,$d1,$55,$c2,$45,$51,$45,$c2,$49,$c9,$d2,$ba,$41,$ff,$ff,$82,$00,$00,$00,$00
 dc.b $44,$51,$55,$02,$45,$51,$45,$02,$49,$49,$52,$aa,$40,$e0,$00,$02,$02,$00,$14,$3c
 dc.b $44,$4a,$45,$02,$44,$4a,$49,$02,$49,$49,$52,$aa,$40,$60,$00,$02,$05,$00,$08,$20
 dc.b $44,$44,$45,$e2,$44,$44,$71,$e2,$4d,$49,$59,$12,$40,$20,$00,$02,$07,$00,$14,$40
 dc.b $20,$00,$00,$04,$20,$00,$00,$04,$20,$00,$00,$04,$20,$00,$00,$04,$05,$00,$01,$40
 dc.b $1c,$00,$00,$38,$1c,$00,$00,$38,$1c,$00,$00,$38,$1c,$00,$00,$38,$02,$00,$00,$80
 dc.b $03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$03,$ff,$ff,$c0
 dc.b $03,$0c,$80,$00,$00,$30,$07,$ff,$ff,$ff,$fe,$ff,$ff,$ff,$ff,$ff,$1c,$00,$00,$38
 dc.b $0d,$12,$80,$00,$40,$3c,$04,$7d,$ff,$ff,$6a,$8f,$ff,$cf,$ff,$fb,$20,$01,$00,$04
 dc.b $31,$10,$80,$00,$00,$3f,$05,$fd,$ef,$c6,$aa,$bf,$f8,$bf,$ff,$db,$40,$02,$80,$02
 dc.b $41,$10,$87,$33,$4e,$3f,$84,$44,$54,$7e,$a6,$8c,$cf,$bc,$8c,$ab,$40,$04,$40,$02
 dc.b $31,$10,$89,$44,$50,$3f,$05,$d5,$cd,$c6,$aa,$bd,$b8,$ba,$ab,$9b,$40,$00,$00,$02
 dc.b $0d,$12,$a9,$33,$52,$3c,$04,$56,$65,$ff,$6a,$89,$cf,$cc,$ac,$cd,$20,$00,$00,$04
 dc.b $03,$0c,$47,$66,$4c,$30,$07,$ff,$ff,$ff,$fe,$ff,$ff,$ff,$ff,$ff,$1c,$00,$00,$38
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$03,$ff,$ff,$c0
accenttype89t: dc.b 0 ;type of the selected accent
txt_inv89t: dc.b '^',173,'1',0
txt_10exp89t: dc.b '10^(',0
txt_square89t: dc.b '^2',0
txt_cube89t: dc.b '^3',0
txt_grad89t: dc.b 170,0
txt_sigma89t: dc.b 142,'(',0
funcbuffer89t: ds.b 21
kbdprgmcall89t: dc.w endkbdprgmcall89t-startkbdprgmcall89t
startkbdprgmcall89t: dc.b $e9,$e5,0,'main\kbdprgm'
kbdprgmno89t: dc.b '7',0,$da
endkbdprgmcall89t:
classicmode89t: dc.b 0 ;non-0: classic mode, 0: modern mode
endevent89t:

 EVEN ;avoid silly alignment problems
      ;("Address Error" etc.)

newevent92p: ;event hook for TI-92+/V200 AMS <3.10
 dc.b 'evHkXtraKeys' ;signature "evHk" + program name
                      ;(for event hook uninstaller)
oldevent92p: dc.l 0 ;placeholder for old event hook
                    ;0 if none
                    ;placed here for easier and
                    ;program- and version-independent
                    ;uninstalling
 movem.l a0-a6/d0-d7,-(a7) ;save all registers
 move.l 64(a7),a2 ;a2=event structure address (a2 for TEOS)
 cmp.w #$700,(a2) ;check if CM_IDLE or CM_BLINK
 beq idle92p
 cmp.w #$740,(a2)
 bne notidle92p
idle92p:
 lea.l statusflags92p(PC),a0 ;if yes, save the status flags
 move.w (a0),2(a0)
 move.w 6(a2),(a0)
notidle92p:
 cmp.w #$710,(a2) ;check if CM_KEYPRESS
 bne notkeypress92p ;if not, do nothing
 move.w #$700,-(a7)
 ROM_CALL OSSetSR ;disable interrupts
;"rowread" routine
 move.w #$fe,$600018 ;read the keyboard directly to get the
 nop                 ;info TI's event stucture doesn't give
 nop                 ;out (The key modifiers are not given
 nop                 ;if we need them, only if we don't
 nop                 ;need them. Don't ask me why.)
 nop
 nop
 nop
 nop ;The return value is automatically put in $60001b by
 nop ;the hardware.
 move.w 10(a2),d5 ;d5 = keycode
;I'm putting this here to reduce the number of needed NOPs
;from 12 to 9.
 move.b $60001b,d3 ;save the result of rowread to d3
 clr.w (a7)
 ROM_CALL OSSetSR ;reenable interrupts
 addq.l #2,a7
 move.w statusflags292p(PC),d1 ;d1 = status flags
 cmp.w #$107,d5 ;check if CLEAR
 bne notclear92p
 btst.l #0,d1 ;check if sequential 2nd+CLEAR
 bne clear2nd92p
 btst.b #0,d3 ;check if simultaneous 2nd+CLEAR
 bne notclear92p
clear2nd92p:
 move.w #$723,(a2) ;change event to CM_STRING
 lea.l txt_10exp92p(PC),a0 ;insert 10^(
 move.l a0,8(a2)
 bra notkeypress92p ;do nothing more
notclear92p:
 cmp.w #$2107,d5 ;check if DIAMOND+CLEAR
 bne notdiamclear92p
 move.l #$1000a,-(a7)
 pea.l logtag92p(PC)
 ROM_CALL Parse1DExpr ;convert log to local string
 addq.l #8,a7
 tst.w d0 ;check if NULL handle
 beq notkeypress92p ;if yes, don't treat the keypress
 move.w d0,-(a7)
 ROM_CALL HeapDeref
 lea.l funcbuffer92p(PC),a1
 move.l a1,a3
lognext92p:
 move.b (a0),(a1)+
 cmp.b #'(',(a0)+
 bne lognext92p
 clr.b (a1)
 ROM_CALL HeapFree
 addq.l #2,a7
 move.w #$723,(a2) ;change event to CM_STRING
 move.l a3,8(a2) ;insert log(
 bra notkeypress92p ;do nothing more
notdiamclear92p:
 cmp.w #$10a,d5 ;check if MODE
 bne notmode92p
 btst.l #0,d1 ;check if sequential 2nd+MODE
 bne mode2nd92p
 btst.b #0,d3 ;check if simultaneous 2nd+MODE
 bne notmode92p
mode2nd92p:
 move.w #$723,(a2) ;change event to CM_STRING
 move.l window92p(PC),a3 ;check if home screen is active
 btst.b #7,(a3)
 beq simplesquare92p
 move.l params92p(PC),a3
 btst.b #1,16(a3) ;if yes, check if cursor is in entry line
 beq simplesquare92p
 tst.w (a3) ;if yes, check if ans(1) should be added
 beq anssquare92p
 btst.b #5,17(a3)
 beq simplesquare92p
 tst.w 6(a3)
 bne notbeginning292p
 move.w 2(a3),d2
 cmp.w (a3),d2
 bne simplesquare92p
 bra anssquare92p
notbeginning292p:
 tst.w 2(a3)
 bne simplesquare92p
 move.w 6(a3),d2
 cmp.w (a3),d2
 bne simplesquare92p
anssquare92p:
 move.l #$1000b,-(a7)
 pea.l ans1tag92p(PC)
 ROM_CALL Parse1DExpr ;convert ans(1) to local string
 addq.l #8,a7
 tst.w d0 ;check if NULL handle
 beq simplesquare92p ;if yes, don't add ans(1)
 move.w d0,-(a7)
 ROM_CALL HeapDeref
 lea.l funcbuffer92p(PC),a1
 move.l a1,a3
anssquarenext92p: ;add ^2 to ans(1)
 move.b (a0),(a1)+
 cmp.b #')',(a0)+
 bne anssquarenext92p
 move.b #'^',(a1)+
 move.b #'2',(a1)+
 clr.b (a1)
 ROM_CALL HeapFree
 addq.l #2,a7
 move.l a3,8(a2)
 bra notkeypress92p ;do nothing more
simplesquare92p:
 lea.l txt_square92p(PC),a0 ;insert ^2
 move.l a0,8(a2)
 bra notkeypress92p ;do nothing more
notmode92p:
 cmp.w #$210a,d5 ;check if DIAMOND+MODE
 bne notdiammode92p
 move.w #$723,(a2) ;change event to CM_STRING
 move.l window92p(PC),a3 ;check if home screen is active
 btst.b #7,(a3)
 beq simplecube92p
 move.l params92p(PC),a3
 btst.b #1,16(a3) ;if yes, check if cursor is in entry line
 beq simplecube92p
 tst.w (a3) ;if yes, check if ans(1) should be added
 beq anscube92p
 btst.b #5,17(a3)
 beq simplecube92p
 tst.w 6(a3)
 bne notbeginning392p
 move.w 2(a3),d2
 cmp.w (a3),d2
 bne simplecube92p
 bra anscube92p
notbeginning392p:
 tst.w 2(a3)
 bne simplecube92p
 move.w 6(a3),d2
 cmp.w (a3),d2
 bne simplecube92p
anscube92p:
 move.l #$1000b,-(a7)
 pea.l ans1tag92p(PC)
 ROM_CALL Parse1DExpr ;convert ans(1) to local string
 addq.l #8,a7
 tst.w d0 ;check if NULL handle
 beq simplecube92p ;if yes, don't add ans(1)
 move.w d0,-(a7)
 ROM_CALL HeapDeref
 lea.l funcbuffer92p(PC),a1
 move.l a1,a3
anscubenext92p: ;add ^3 to ans(1)
 move.b (a0),(a1)+
 cmp.b #')',(a0)+
 bne anscubenext92p
 move.b #'^',(a1)+
 move.b #'3',(a1)+
 clr.b (a1)
 ROM_CALL HeapFree
 addq.l #2,a7
 move.l a3,8(a2)
 bra notkeypress92p ;do nothing more
simplecube92p:
 lea.l txt_cube92p(PC),a0 ;insert ^3
 move.l a0,8(a2)
 bra notkeypress92p ;do nothing more
notdiammode92p:
 cmp.w #$205e,d5 ;check if DIAMOND+^
 bne notdiampower92p
 move.w #$723,(a2) ;change event to CM_STRING
 lea.l txt_xroot92p(PC),a0 ;insert x\root(
 move.l a0,8(a2)
 bra notkeypress92p ;do nothing more
notdiampower92p:
 cmp.w #$2106,d5 ;check if DIAMOND+ln
 bne notdiamln92p
 move.w #$723,(a2) ;change event to CM_STRING
 lea.l txt_xlog92p(PC),a0 ;insert x\logy(
 move.l a0,8(a2)
 bra notkeypress92p ;do nothing more
notdiamln92p:
 cmp.w #$2103,d5 ;check if DIAMOND+sin
 bne notdiamsin92p
 move.l #$1000a,-(a7)
 pea.l abstag92p(PC)
 ROM_CALL Parse1DExpr ;convert abs to local string
 addq.l #8,a7
 tst.w d0 ;check if NULL handle
 beq notkeypress92p ;if yes, don't treat the keypress
 move.w d0,-(a7)
 ROM_CALL HeapDeref
 lea.l funcbuffer92p(PC),a1
 move.l a1,a3
absnext92p:
 move.b (a0),(a1)+
 cmp.b #'(',(a0)+
 bne absnext92p
 clr.b (a1)
 ROM_CALL HeapFree
 addq.l #2,a7
 move.w #$723,(a2) ;change event to CM_STRING
 move.l a3,8(a2) ;insert abs(
 bra notkeypress92p ;do nothing more
notdiamsin92p:
 cmp.w #$2104,d5 ;check if DIAMOND+cos
 bne notdiamcos92p
 move.l #$1000a,-(a7)
 pea.l ncrtag92p(PC)
 ROM_CALL Parse1DExpr ;convert nCr to local string
 addq.l #8,a7
 tst.w d0 ;check if NULL handle
 beq notkeypress92p ;if yes, don't treat the keypress
 move.w d0,-(a7)
 ROM_CALL HeapDeref
 lea.l funcbuffer92p(PC),a1
 move.l a1,a3
ncrnext92p:
 move.b (a0),(a1)+
 cmp.b #'(',(a0)+
 bne ncrnext92p
 clr.b (a1)
 ROM_CALL HeapFree
 addq.l #2,a7
 move.w #$723,(a2) ;change event to CM_STRING
 move.l a3,8(a2) ;insert nCr(
 bra notkeypress92p ;do nothing more
notdiamcos92p:
 cmp.w #$2105,d5 ;check if DIAMOND+tan
 bne notdiamtan92p
 move.l #$1000a,-(a7)
 pea.l nprtag92p(PC)
 ROM_CALL Parse1DExpr ;convert nPr to local string
 addq.l #8,a7
 tst.w d0 ;check if NULL handle
 beq notkeypress92p ;if yes, don't treat the keypress
 move.w d0,-(a7)
 ROM_CALL HeapDeref
 lea.l funcbuffer92p(PC),a1
 move.l a1,a3
nprnext92p:
 move.b (a0),(a1)+
 cmp.b #'(',(a0)+
 bne nprnext92p
 clr.b (a1)
 ROM_CALL HeapFree
 addq.l #2,a7
 move.w #$723,(a2) ;change event to CM_STRING
 move.l a3,8(a2) ;insert nPr(
 bra notkeypress92p ;do nothing more
notdiamtan92p:
 cmp.w #$2108,d5 ;check if DIAMOND+ESC
 bne notdiamesc92p
 clr.w -(a7)        ;hide diamond indicator now (else the
 ROM_CALL ST_modKey ;auto-int 1 will do it, but too late)
 subq.l #2,a7
 move.l #3840,(a7)
 ROM_CALL HeapAllocPtr
 move.l a0,d4 ;save the address to d4
 tst.l d4
 beq diamescnomem92p ;if NULL pointer, don't display key map
 move.l #$4c00,-(a7)
 move.l d4,-(a7)
 ROM_CALL memcpy ;save the screen
 addq.l #8,a7
 pea.l keymap92p(PC)
 move.l #$4c00,-(a7)
 ROM_CALL memcpy ;display the key map
 addq.l #6,a7
 move.w #2,(a7)
 ROM_CALL FontSetSys
 move.w d0,(a7)
 clr.w -(a7)
 pea.l keymaptext92p(PC)
 move.l #$59006e,-(a7)
 ROM_CALL DrawStr
 lea.l 10(a7),a7
 ROM_CALL FontSetSys
 subq.l #2,a7
 ROM_CALL ngetchx ;wait for a keypress
 move.l d4,(a7)
 move.l #$4c00,-(a7)
 ROM_CALL memcpy ;restore the screen
 addq.l #4,a7
 ROM_CALL HeapFreePtr
 addq.l #4,a7
diamescnomem92p:
 addq.l #4,a7
 move.w #$700,(a2) ;change event to CM_IDLE
 bra notkeypress92p ;do nothing more
notdiamesc92p:
 cmp.w #$2028,d5 ;check if DIAMOND+(
 bne notkeypress92p
 lea.l event92p(PC),a0
 move.w #$710,(a0)
 lea.l event_keycode92p(PC),a0 ;insert the keycode of the Napier / Euler e into
 move.l #150*65536+150,(a0)    ;the event structure
 pea.l event92p(PC) ;CM_KEYPRESS event for the Napier/Euler e
 move.w #-2,-(a7)
 ROM_CALL EV_sendEvent ;send the CM_KEYPRESS event to the current application
 addq.l #6,a7 ;We have to send an additional event because we have to keep the
              ;self-test key working.
notkeypress92p:
 move.l oldevent92p(PC),a0 ;a0 = old event hook
 cmp.l #0,a0 ;check if 0 (tst refuses this addressing mode)
 beq nooldevent92p ;if 0 do nothing
 move.l 64(a7),a2 ;pass event structure in a2 (for TeOS)
 move.l a2,-(a7) ;pass event structure as an argument
 jsr (a0) ;run the old event hook
 addq.l #4,a7
nooldevent92p:
 movem.l (a7)+,a0-a6/d0-d7 ;restore all registers
 rts ;return
 EVEN ;avoid silly alignment problems
      ;("Address Error" etc.)
statusflags92p: dc.w 0 ;placeholder for the status flags
statusflags292p: dc.w 0
params92p: dc.l $6016;position of the home screen entry line
                     ;parameters
window92p: dc.l $6071;position of the 2nd byte of the home
                     ;screen window flags (containing the
                     ;"active" flag)
;Those values may be adjusted for different AMS versions.
event92p: ;event structure for EV_sendEvent
 dc.w $710 ;type = CM_STRING
 ds.b 6 ;RunningApp (2), Side (2), StatusFlags (2)
event_keycode92p:
 dc.w 150,150 ;Mod (2), Code (2)
 ds.b 2 ;StartType (2)
keymap92p:
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01,$13,$e4,$40,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $04,$1c,$00,$00,$00,$01,$07,$00,$00,$00,$00,$00,$01,$22,$02,$80,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $0a,$22,$00,$00,$00,$02,$88,$80,$00,$00,$00,$00,$01,$42,$01,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $11,$02,$00,$00,$00,$04,$40,$80,$00,$00,$00,$00,$01,$83,$c1,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$04,$00,$00,$00,$00,$07,$00,$00,$00,$00,$00,$01,$42,$01,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$08,$00,$00,$00,$00,$00,$80,$0e,$22,$39,$f0,$01,$22,$01,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$10,$00,$00,$00,$00,$08,$80,$11,$22,$10,$40,$01,$13,$e1,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$3e,$00,$00,$00,$00,$07,$00,$11,$22,$10,$40,$00,$00,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$11,$22,$10,$40,$00,$00,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$11,$22,$10,$40,$01,$10,$87,$80,$01,$00,$00,$00,$00,$00,$00,$10,$00,$00,$10,$00,$00,$00
 dc.b $1f,$ff,$ff,$ff,$ff,$ff,$ff,$80,$0e,$22,$10,$40,$01,$b1,$44,$40,$01,$00,$00,$00,$00,$00,$00,$10,$00,$00,$10,$00,$00,$00
 dc.b $10,$00,$00,$00,$00,$00,$00,$80,$01,$1c,$38,$40,$01,$52,$24,$40,$01,$00,$00,$00,$00,$00,$00,$10,$00,$00,$38,$00,$00,$00
 dc.b $10,$00,$00,$00,$00,$00,$00,$80,$00,$00,$00,$00,$01,$12,$27,$80,$01,$00,$00,$00,$00,$00,$00,$10,$00,$00,$38,$00,$00,$00
 dc.b $10,$00,$88,$e3,$87,$c0,$00,$80,$00,$00,$00,$00,$01,$13,$e4,$00,$01,$00,$00,$00,$00,$0e,$2c,$70,$00,$00,$7c,$00,$00,$00
 dc.b $10,$00,$d9,$12,$44,$00,$00,$80,$00,$00,$00,$00,$01,$12,$24,$00,$01,$00,$00,$00,$00,$11,$32,$90,$00,$00,$7c,$00,$00,$00
 dc.b $10,$00,$a9,$12,$24,$00,$00,$80,$00,$00,$00,$00,$01,$12,$24,$00,$01,$00,$00,$00,$00,$20,$a2,$90,$00,$00,$fe,$00,$00,$00
 dc.b $10,$00,$89,$12,$27,$80,$00,$80,$00,$00,$00,$00,$00,$00,$00,$00,$01,$00,$00,$00,$00,$00,$a2,$60,$00,$00,$fe,$00,$00,$00
 dc.b $10,$00,$89,$12,$24,$00,$00,$80,$00,$7f,$ff,$ff,$ff,$fc,$00,$00,$01,$00,$00,$00,$04,$00,$80,$00,$00,$81,$ff,$00,$00,$00
 dc.b $10,$00,$89,$12,$44,$00,$00,$80,$00,$40,$00,$00,$00,$04,$00,$00,$01,$00,$00,$00,$04,$00,$80,$00,$00,$81,$ff,$00,$00,$00
 dc.b $10,$00,$88,$e3,$87,$c0,$00,$80,$00,$40,$00,$00,$00,$04,$00,$00,$01,$00,$00,$00,$04,$01,$00,$00,$00,$83,$ff,$80,$00,$00
 dc.b $10,$00,$00,$00,$00,$00,$00,$80,$00,$40,$00,$00,$00,$04,$00,$00,$01,$00,$00,$00,$3f,$82,$00,$00,$07,$f3,$ff,$80,$00,$00
 dc.b $1f,$ff,$ff,$ff,$ff,$ff,$ff,$80,$00,$5f,$f8,$1e,$01,$f4,$00,$00,$01,$00,$00,$00,$04,$04,$00,$00,$00,$81,$ff,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$50,$00,$21,$02,$04,$00,$00,$01,$00,$00,$00,$04,$08,$00,$00,$00,$81,$ff,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$50,$00,$40,$84,$04,$00,$00,$01,$00,$00,$00,$04,$10,$00,$00,$00,$80,$fe,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$50,$00,$80,$44,$04,$00,$00,$01,$00,$00,$00,$00,$20,$00,$00,$00,$00,$fe,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$50,$00,$80,$08,$04,$00,$00,$01,$00,$00,$00,$00,$3f,$80,$00,$00,$00,$7c,$00,$00,$00
 dc.b $04,$38,$20,$00,$00,$0c,$00,$00,$00,$50,$01,$00,$08,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$7c,$00,$00,$00
 dc.b $0c,$44,$50,$00,$00,$04,$00,$00,$00,$50,$01,$00,$08,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$38,$00,$00,$00
 dc.b $14,$44,$88,$00,$00,$04,$63,$00,$00,$50,$01,$00,$08,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$38,$00,$00,$00
 dc.b $04,$44,$00,$00,$00,$04,$94,$80,$00,$50,$01,$00,$08,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$10,$00,$00,$00
 dc.b $04,$44,$00,$00,$00,$04,$94,$80,$00,$50,$01,$00,$08,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$10,$00,$00,$00
 dc.b $04,$44,$00,$00,$00,$0e,$63,$80,$00,$50,$01,$00,$08,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $0e,$38,$00,$00,$00,$00,$00,$80,$00,$50,$01,$00,$08,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$07,$00,$00,$50,$01,$00,$08,$04,$00,$00,$01,$00,$00,$00,$3f,$ff,$ff,$ff,$ff,$ff,$ff,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$50,$00,$80,$08,$04,$00,$00,$01,$00,$00,$00,$3f,$ff,$ff,$ff,$ff,$ff,$ff,$00,$00,$00
 dc.b $1f,$ff,$ff,$ff,$ff,$ff,$ff,$80,$00,$50,$00,$80,$08,$04,$00,$00,$01,$00,$00,$00,$3f,$ff,$dd,$c1,$df,$7f,$ff,$00,$00,$00
 dc.b $10,$00,$00,$00,$00,$00,$00,$80,$00,$50,$00,$40,$08,$04,$00,$00,$01,$00,$00,$00,$3f,$ff,$db,$df,$ee,$ff,$ff,$00,$00,$00
 dc.b $10,$00,$00,$00,$00,$00,$00,$80,$00,$50,$00,$20,$08,$04,$00,$00,$01,$00,$00,$00,$3f,$ff,$d7,$df,$f5,$ff,$ff,$00,$00,$00
 dc.b $10,$01,$c8,$1f,$08,$78,$00,$80,$00,$50,$00,$10,$08,$04,$00,$00,$01,$00,$00,$00,$3f,$ff,$cf,$c3,$fb,$ff,$ff,$00,$00,$00
 dc.b $10,$02,$08,$10,$14,$44,$00,$80,$00,$50,$00,$08,$08,$04,$00,$00,$01,$00,$00,$00,$3f,$ff,$d7,$df,$fb,$ff,$ff,$00,$00,$00
 dc.b $10,$04,$08,$10,$22,$44,$00,$80,$00,$5f,$f0,$04,$08,$04,$00,$00,$01,$00,$00,$00,$3f,$ff,$db,$df,$fb,$ff,$ff,$00,$00,$00
 dc.b $10,$04,$08,$1e,$22,$78,$00,$80,$00,$50,$00,$02,$08,$04,$00,$00,$01,$00,$00,$00,$3f,$ff,$dd,$df,$fb,$ff,$ff,$00,$00,$00
 dc.b $10,$04,$08,$10,$3e,$50,$00,$80,$00,$50,$00,$01,$08,$04,$00,$00,$01,$00,$00,$00,$3f,$ff,$dd,$c1,$fb,$ff,$ff,$00,$00,$00
 dc.b $10,$02,$08,$10,$22,$48,$00,$80,$00,$50,$00,$00,$88,$04,$00,$00,$01,$00,$00,$00,$3f,$ff,$ff,$ff,$ff,$ff,$ff,$00,$00,$00
 dc.b $10,$01,$cf,$9f,$22,$44,$00,$80,$00,$50,$00,$00,$88,$04,$00,$00,$01,$00,$00,$00,$3f,$ff,$ff,$ff,$ff,$ff,$ff,$00,$00,$00
 dc.b $10,$00,$00,$00,$00,$00,$00,$80,$00,$50,$00,$00,$48,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $1f,$ff,$ff,$ff,$ff,$ff,$ff,$80,$00,$50,$00,$00,$48,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$50,$00,$00,$48,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$50,$00,$00,$48,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$50,$00,$00,$48,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$50,$00,$00,$48,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$10,$00,$00,$00,$0c,$00,$00,$00,$50,$00,$00,$48,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$28,$00,$00,$00,$04,$00,$00,$00,$50,$00,$00,$48,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $06,$44,$00,$00,$00,$04,$63,$00,$00,$50,$00,$00,$48,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $09,$00,$00,$00,$00,$04,$94,$80,$00,$50,$00,$00,$48,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $1e,$00,$00,$00,$00,$04,$94,$80,$00,$50,$00,$00,$88,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $10,$00,$00,$00,$00,$ae,$63,$80,$00,$50,$01,$00,$84,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $0c,$00,$00,$00,$00,$40,$00,$80,$00,$50,$00,$81,$04,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$a0,$07,$00,$00,$50,$00,$42,$02,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$5f,$fc,$3c,$01,$f4,$00,$00,$01,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
 dc.b $1f,$ff,$ff,$ff,$ff,$ff,$ff,$80,$00,$40,$00,$00,$00,$04,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $10,$00,$00,$00,$00,$00,$00,$80,$00,$40,$00,$00,$00,$04,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $10,$00,$00,$00,$00,$00,$00,$80,$00,$7f,$ff,$ff,$ff,$fc,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $10,$00,$00,$81,$10,$00,$00,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $10,$00,$00,$81,$90,$00,$00,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $10,$00,$00,$81,$50,$00,$00,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $10,$00,$00,$81,$50,$00,$00,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $10,$00,$00,$81,$50,$00,$00,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $10,$00,$00,$81,$30,$00,$00,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $10,$00,$00,$f9,$10,$00,$00,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $10,$00,$00,$00,$00,$00,$00,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $1f,$ff,$ff,$ff,$ff,$ff,$ff,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$04,$00,$00,$00,$00,$00,$00,$00,$20,$00,$00,$00,$00,$00,$00,$02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$0c,$00,$00,$00,$00,$00,$00,$00,$60,$00,$00,$00,$00,$00,$00,$06,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$64,$00,$00,$00,$00,$00,$00,$03,$20,$00,$00,$0e,$00,$00,$00,$32,$00,$00,$01,$e0,$00,$00,$00,$00,$00,$00,$28,$00
 dc.b $00,$40,$04,$00,$00,$00,$80,$00,$00,$00,$20,$00,$00,$11,$00,$10,$00,$02,$00,$00,$01,$10,$00,$00,$00,$00,$00,$00,$10,$00
 dc.b $00,$00,$04,$00,$00,$00,$80,$00,$00,$00,$20,$00,$00,$10,$00,$10,$00,$02,$00,$00,$01,$10,$00,$00,$00,$00,$00,$00,$29,$f8
 dc.b $0e,$ca,$00,$00,$00,$0a,$e3,$80,$e6,$38,$00,$00,$02,$90,$58,$1c,$55,$00,$00,$00,$29,$15,$81,$f8,$00,$00,$00,$00,$02,$00
 dc.b $10,$4d,$00,$00,$00,$16,$94,$01,$09,$40,$00,$00,$03,$50,$60,$10,$b6,$80,$00,$00,$35,$e6,$00,$90,$00,$00,$00,$00,$02,$00
 dc.b $0c,$49,$00,$00,$00,$12,$93,$01,$09,$30,$00,$00,$02,$50,$40,$10,$94,$80,$00,$00,$25,$04,$00,$90,$00,$00,$00,$00,$24,$00
 dc.b $02,$49,$00,$00,$00,$16,$90,$81,$09,$08,$00,$00,$02,$51,$40,$12,$b4,$80,$00,$00,$25,$04,$00,$90,$00,$00,$00,$00,$14,$00
 dc.b $1c,$e9,$00,$00,$00,$0a,$67,$00,$e6,$70,$00,$00,$02,$4e,$40,$0c,$54,$80,$00,$00,$25,$04,$00,$90,$00,$00,$00,$00,$08,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $1f,$ff,$ff,$ff,$ff,$ff,$ff,$81,$ff,$ff,$ff,$ff,$ff,$ff,$f8,$1f,$ff,$ff,$ff,$ff,$ff,$ff,$81,$ff,$ff,$ff,$ff,$ff,$ff,$f8
 dc.b $10,$00,$00,$00,$00,$00,$00,$81,$00,$00,$00,$00,$00,$00,$08,$10,$00,$00,$00,$00,$00,$00,$81,$00,$00,$00,$00,$00,$00,$08
 dc.b $10,$00,$00,$00,$00,$00,$00,$81,$00,$00,$00,$00,$00,$00,$08,$10,$00,$00,$00,$00,$00,$00,$81,$00,$00,$00,$00,$00,$00,$08
 dc.b $10,$00,$03,$87,$11,$00,$00,$81,$00,$00,$38,$e1,$c0,$00,$08,$10,$00,$0f,$84,$22,$00,$00,$81,$00,$00,$00,$10,$00,$00,$08
 dc.b $10,$00,$04,$42,$19,$00,$00,$81,$00,$00,$41,$12,$20,$00,$08,$10,$00,$02,$0a,$32,$00,$00,$81,$00,$00,$00,$28,$00,$00,$08
 dc.b $10,$00,$04,$02,$15,$00,$00,$81,$00,$00,$81,$12,$00,$00,$08,$10,$00,$02,$11,$2a,$00,$00,$81,$00,$00,$00,$44,$00,$00,$08
 dc.b $10,$00,$03,$82,$15,$00,$00,$81,$00,$00,$81,$11,$c0,$00,$08,$10,$00,$02,$11,$2a,$00,$00,$81,$00,$00,$00,$00,$00,$00,$08
 dc.b $10,$00,$00,$42,$15,$00,$00,$81,$00,$00,$81,$10,$20,$00,$08,$10,$00,$02,$1f,$2a,$00,$00,$81,$00,$00,$00,$00,$00,$00,$08
 dc.b $10,$00,$04,$42,$13,$00,$00,$81,$00,$00,$41,$12,$20,$00,$08,$10,$00,$02,$11,$26,$00,$00,$81,$00,$00,$00,$00,$00,$00,$08
 dc.b $10,$00,$03,$87,$11,$00,$00,$81,$00,$00,$38,$e1,$c0,$00,$08,$10,$00,$02,$11,$22,$00,$00,$81,$00,$00,$00,$00,$00,$00,$08
 dc.b $10,$00,$00,$00,$00,$00,$00,$81,$00,$00,$00,$00,$00,$00,$08,$10,$00,$00,$00,$00,$00,$00,$81,$00,$00,$00,$00,$00,$00,$08
 dc.b $1f,$ff,$ff,$ff,$ff,$ff,$ff,$81,$ff,$ff,$ff,$ff,$ff,$ff,$f8,$1f,$ff,$ff,$ff,$ff,$ff,$ff,$81,$ff,$ff,$ff,$ff,$ff,$ff,$f8
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $06,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $08,$00,$00,$00,$00,$00,$00,$00,$00,$1f,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$80
 dc.b $08,$00,$00,$00,$00,$00,$03,$00,$00,$7f,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$e0
 dc.b $10,$00,$00,$00,$00,$00,$04,$80,$00,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$f0
 dc.b $08,$00,$00,$00,$00,$00,$0f,$00,$01,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$f8
 dc.b $08,$00,$00,$00,$00,$00,$08,$00,$03,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$fc
 dc.b $06,$00,$00,$00,$00,$00,$06,$00,$03,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$fc
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$07,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$fe
 dc.b $1f,$ff,$ff,$ff,$ff,$ff,$ff,$80,$07,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$fe
 dc.b $10,$00,$00,$00,$00,$00,$00,$80,$07,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$fe
 dc.b $10,$00,$00,$01,$00,$00,$00,$80,$07,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$fe
 dc.b $10,$00,$00,$02,$00,$00,$00,$80,$07,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$fe
 dc.b $10,$00,$00,$04,$00,$00,$00,$80,$07,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$fe
 dc.b $10,$00,$00,$04,$00,$00,$00,$80,$07,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$fe
 dc.b $10,$00,$00,$04,$00,$00,$00,$80,$03,$f0,$73,$bb,$1d,$6f,$df,$d7,$eb,$7f,$ee,$df,$fb,$5b,$ff,$fe,$ff,$ff,$ec,$ff,$ef,$fc
 dc.b $10,$00,$00,$04,$00,$00,$00,$80,$03,$e3,$3d,$55,$7c,$d5,$73,$ce,$da,$ab,$e2,$49,$b6,$ce,$6a,$aa,$f3,$61,$da,$d6,$7c,$fc
 dc.b $10,$00,$00,$02,$00,$00,$00,$80,$01,$e4,$3b,$55,$9c,$cd,$55,$cd,$4a,$67,$ea,$da,$f6,$da,$aa,$a6,$ee,$aa,$d8,$56,$eb,$f8
 dc.b $10,$00,$00,$01,$00,$00,$00,$80,$00,$e3,$31,$bb,$3d,$66,$d5,$d6,$db,$2f,$eb,$69,$ad,$ea,$b7,$2e,$b3,$6a,$be,$e4,$ec,$f0
 dc.b $10,$00,$00,$00,$00,$00,$00,$80,$00,$70,$7f,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$fb,$ff,$ff,$ef,$ff,$ff,$ff,$ff,$ff,$df,$e0
 dc.b $1f,$ff,$ff,$ff,$ff,$ff,$ff,$80,$00,$1f,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$80
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
keymaptext92p: dc.b 'XtraKeys v. 3.00',0
txt_10exp92p: dc.b '10^(',0
txt_square92p: dc.b '^2',0
txt_cube92p: dc.b '^3',0
txt_xroot92p: dc.b 'x\root(',0
txt_xlog92p: dc.b 'x\logy(',0
 dc.b $08 ;tokenized expressions for localization support
abstag92p: dc.b $4b
 dc.b $08
logtag92p: dc.b $54
 dc.b $09,$08
ncrtag92p: dc.b $a7
 dc.b $09,$08
nprtag92p: dc.b $a8
 dc.b $e5,$01,$01,$1f
ans1tag92p: dc.b $bc
funcbuffer92p: ds.b 15
endevent92p:

 EVEN ;avoid silly alignment problems
      ;("Address Error" etc.)

neweventv200: ;event hook for Voyage 200 AMS >=3.10
 dc.b 'evHkXtraKeys' ;signature "evHk" + program name
                      ;(for event hook uninstaller)
oldeventv200: dc.l 0 ;placeholder for old event hook
                     ;0 if none
                     ;placed here for easier and
                     ;program- and version-independent
                     ;uninstalling
 movem.l a0-a6/d0-d7,-(a7) ;save all registers
 move.l 64(a7),a2 ;a2=event structure address (a2 for TEOS)
 cmp.w #$700,(a2) ;check if CM_IDLE or CM_BLINK
 beq idlev200
 cmp.w #$740,(a2)
 bne notidlev200
idlev200:
 lea.l statusflagsv200(PC),a0 ;if yes, save the status flags
 move.w (a0),2(a0)
 move.w 6(a2),(a0)
notidlev200:
 cmp.w #$710,(a2) ;check if CM_KEYPRESS
 bne notkeypressv200 ;if not, do nothing
 move.w #$700,-(a7)
 dc.w $F800+OSSetSR ;disable interrupts
;"rowread" routine
 move.w #$fe,$600018 ;read the keyboard directly to get the
 nop                 ;info TI's event stucture doesn't give
 nop                 ;out (The key modifiers are not given
 nop                 ;if we need them, only if we don't
 nop                 ;need them. Don't ask me why.)
 nop
 nop
 nop
 nop ;The return value is automatically put in $60001b by
 nop ;the hardware.
 move.w 10(a2),d5 ;d5 = keycode
;I'm putting this here to reduce the number of needed NOPs
;from 12 to 9.
 move.b $60001b,d3 ;save the result of rowread to d3
 clr.w (a7)
 dc.w $F800+OSSetSR ;reenable interrupts
 addq.l #2,a7
 move.w statusflags2v200(PC),d1 ;d1 = status flags
 cmp.w #8247,d5 ;check if DIAMOND+7
 bne notdiam7v200
 move.b classicmodev200(PC),d0
 beq notkeypressv200 ;only in classic mode
 moveq #'7',d0
 bra runkbdprgmv200
notdiam7v200:
 cmp.w #8248,d5 ;check if DIAMOND+8
 bne notdiam8v200
 moveq #'8',d0
runkbdprgmv200:
 move.w #$700,(a2) ;change event to CM_IDLE
 lea kbdprgmnov200(PC),a0
 move.b d0,(a0)
 clr.w -(a7)
 lea -60(a7),a7
 pea.l (a7)
 dc.w $F800+ER_catch
 addq.l #4,a7
 tst.w d0
 bne runkbdprgmerrorv200
 pea.l endkbdprgmcallv200-kbdprgmcallv200
 dc.w $F800+HeapAllocThrow
 move.w d0,64(a7)
 clr.l (a7)
 move.w d0,(a7)
 move.w d0,-(a7)
 dc.w $F800+HLock
 pea.l endkbdprgmcallv200-kbdprgmcallv200
 pea.l kbdprgmcallv200(PC)
 pea.l (a0)
 dc.w $F800+memcpy
 lea.l 14(a7),a7
 dc.w $F800+NG_execute
 addq.l #4,a7
 dc.w $F800+ER_success
 lea.l 60(a7),a7
 dc.w $F800+HeapFree
 addq.l #2,a7
 bra notkeypressv200 ;do nothing more
runkbdprgmerrorv200:
 move.w d0,d4 ;save the error number
 lea.l 60(a7),a7
 tst.w (a7)
 beq runkbdprgmnofreev200
 dc.w $F800+HeapFree
runkbdprgmnofreev200:
 move.w d4,(a7) ;rethrow the error
 dc.w $F800+ER_throwVar
notdiam8v200:
 cmp.w #8249,d5 ;check if DIAMOND+9
 bne notdiam9v200
 move.b classicmodev200(PC),d0
 beq notkeypressv200 ;only in classic mode
 moveq #'9',d0
 bra runkbdprgmv200
notdiam9v200:
 cmp.w #$107,d5 ;check if CLEAR
 bne notclearv200
 btst.l #0,d1 ;check if sequential 2nd+CLEAR
 bne clear2ndv200
 btst.b #0,d3 ;check if simultaneous 2nd+CLEAR
 bne notclearv200
clear2ndv200:
 move.w #$723,(a2) ;change event to CM_STRING
 lea.l txt_10expv200(PC),a0 ;insert 10^(
 move.l a0,8(a2)
 bra notkeypressv200 ;do nothing more
notclearv200:
 cmp.w #$2107,d5 ;check if DIAMOND+CLEAR
 bne notdiamclearv200
 move.b classicmodev200(PC),d0
 bne diamclearclassicv200
 move.w #$723,(a2) ;change event to CM_STRING
 move.l windowv200(PC),a3 ;check if home screen is active
 btst.b #7,(a3)
 beq simpletologbasev200
 move.l paramsv200(PC),a3
 btst.b #1,16(a3) ;if yes, check if cursor is in entry line
 beq simpletologbasev200
 tst.w (a3) ;if yes, check if ans(1) should be added
 beq anstologbasev200
 btst.b #5,17(a3)
 beq simpletologbasev200
 tst.w 6(a3)
 bne notbeginningtologbasev200
 move.w 2(a3),d2
 cmp.w (a3),d2
 bne simpletologbasev200
 bra anstologbasev200
notbeginningtologbasev200:
 tst.w 2(a3)
 bne simpletologbasev200
 move.w 6(a3),d2
 cmp.w (a3),d2
 bne simpletologbasev200
anstologbasev200:
 pea.l 56 ;convert ans(1) to local string
 dc.w $F800+XR_stringPtr
 move.l a0,a4
 pea.l 1816 ;convert >logbase( to local string
 dc.w $F800+XR_stringPtr
 addq.l #8,a7
 lea.l funcbufferv200(PC),a1
 move.l a1,a3
anstologbasenextv200: ;copy ans(1)
 move.b (a4),(a1)+
 cmp.b #')',(a4)+
 bne anstologbasenextv200
anstologbasenext2v200: ;add >logbase( to ans(1)
 move.b (a0),(a1)+
 tst.b (a0)+
 bne anstologbasenext2v200
 move.l a3,8(a2) ;insert ans(1)>logbase(
 bra notkeypressv200 ;do nothing more
simpletologbasev200:
 pea.l 1816 ;convert >logbase( to local string
 dc.w $F800+XR_stringPtr
 addq.l #4,a7
 move.l a0,8(a2) ;insert >logbase(
 bra notkeypressv200 ;do nothing more
diamclearclassicv200:
 move.w #8247,10(a2) ;change key code to DIAMOND+7
 bra notkeypressv200 ;do nothing more
notdiamclearv200:
 cmp.w #$10a,d5 ;check if MODE
 bne notmodev200
 btst.l #0,d1 ;check if sequential 2nd+MODE
 bne mode2ndv200
 btst.b #0,d3 ;check if simultaneous 2nd+MODE
 bne notmodev200
mode2ndv200:
 move.w #$723,(a2) ;change event to CM_STRING
 move.l windowv200(PC),a3 ;check if home screen is active
 btst.b #7,(a3)
 beq simplesquarev200
 move.l paramsv200(PC),a3
 btst.b #1,16(a3) ;if yes, check if cursor is in entry line
 beq simplesquarev200
 tst.w (a3) ;if yes, check if ans(1) should be added
 beq anssquarev200
 btst.b #5,17(a3)
 beq simplesquarev200
 tst.w 6(a3)
 bne notbeginning2v200
 move.w 2(a3),d2
 cmp.w (a3),d2
 bne simplesquarev200
 bra anssquarev200
notbeginning2v200:
 tst.w 2(a3)
 bne simplesquarev200
 move.w 6(a3),d2
 cmp.w (a3),d2
 bne simplesquarev200
anssquarev200:
 pea.l 56 ;convert ans(1) to local string
 dc.w $F800+XR_stringPtr
 addq.l #4,a7
 lea.l funcbufferv200(PC),a1
 move.l a1,a3
anssquarenextv200: ;add ^2 to ans(1)
 move.b (a0),(a1)+
 cmp.b #')',(a0)+
 bne anssquarenextv200
 move.b #'^',(a1)+
 move.b #'2',(a1)+
 clr.b (a1)
 move.l a3,8(a2)
 bra notkeypressv200 ;do nothing more
simplesquarev200:
 lea.l txt_squarev200(PC),a0 ;insert ^2
 move.l a0,8(a2)
 bra notkeypressv200 ;do nothing more
notmodev200:
 cmp.w #$210a,d5 ;check if DIAMOND+MODE
 bne notdiammodev200
 move.w #$723,(a2) ;change event to CM_STRING
 move.l windowv200(PC),a3 ;check if home screen is active
 btst.b #7,(a3)
 beq simplecubev200
 move.l paramsv200(PC),a3
 btst.b #1,16(a3) ;if yes, check if cursor is in entry line
 beq simplecubev200
 tst.w (a3) ;if yes, check if ans(1) should be added
 beq anscubev200
 btst.b #5,17(a3)
 beq simplecubev200
 tst.w 6(a3)
 bne notbeginning3v200
 move.w 2(a3),d2
 cmp.w (a3),d2
 bne simplecubev200
 bra anscubev200
notbeginning3v200:
 tst.w 2(a3)
 bne simplecubev200
 move.w 6(a3),d2
 cmp.w (a3),d2
 bne simplecubev200
anscubev200:
 pea.l 56 ;convert ans(1) to local string
 dc.w $F800+XR_stringPtr
 addq.l #4,a7
 lea.l funcbufferv200(PC),a1
 move.l a1,a3
anscubenextv200: ;add ^3 to ans(1)
 move.b (a0),(a1)+
 cmp.b #')',(a0)+
 bne anscubenextv200
 move.b #'^',(a1)+
 move.b #'3',(a1)+
 clr.b (a1)
 move.l a3,8(a2)
 bra notkeypressv200 ;do nothing more
simplecubev200:
 lea.l txt_cubev200(PC),a0 ;insert ^3
 move.l a0,8(a2)
 bra notkeypressv200 ;do nothing more
notdiammodev200:
 cmp.w #$205e,d5 ;check if DIAMOND+^
 bne notdiampowerv200
 move.b classicmodev200(PC),d0
 bne diampowerclassicv200
 move.w #$723,(a2) ;change event to CM_STRING
diamlnclassicv200:
 lea.l txt_gradv200(PC),a0 ;insert ^G
 move.l a0,8(a2)
 bra notkeypressv200 ;do nothing more
diampowerclassicv200:
 move.w #8249,10(a2) ;change key code to DIAMOND+9
 bra notkeypressv200 ;do nothing more
notdiampowerv200:
 cmp.w #$2106,d5 ;check if DIAMOND+ln
 bne notdiamlnv200
 move.w #$723,(a2) ;change event to CM_STRING
 move.b classicmodev200(PC),d0
 bne diamlnclassicv200
 move.l windowv200(PC),a3 ;check if home screen is active
 btst.b #7,(a3)
 beq simpletolnv200
 move.l paramsv200(PC),a3
 btst.b #1,16(a3) ;if yes, check if cursor is in entry line
 beq simpletolnv200
 tst.w (a3) ;if yes, check if ans(1) should be added
 beq anstolnv200
 btst.b #5,17(a3)
 beq simpletolnv200
 tst.w 6(a3)
 bne notbeginningtolnv200
 move.w 2(a3),d2
 cmp.w (a3),d2
 bne simpletolnv200
 bra anstolnv200
notbeginningtolnv200:
 tst.w 2(a3)
 bne simpletolnv200
 move.w 6(a3),d2
 cmp.w (a3),d2
 bne simpletolnv200
anstolnv200:
 pea.l 56 ;convert ans(1) to local string
 dc.w $F800+XR_stringPtr
 move.l a0,a4
 pea.l 1810 ;convert >ln to local string
 dc.w $F800+XR_stringPtr
 addq.l #8,a7
 lea.l funcbufferv200(PC),a1
 move.l a1,a3
anstolnnextv200: ;copy ans(1)
 move.b (a4),(a1)+
 cmp.b #')',(a4)+
 bne anstolnnextv200
anstolnnext2v200: ;add >ln to ans(1)
 move.b (a0),(a1)+
 tst.b (a0)+
 bne anstolnnext2v200
 move.l a3,8(a2) ;insert ans(1)>ln
 bra notkeypressv200 ;do nothing more
simpletolnv200:
 pea.l 1810 ;convert >ln to local string
 dc.w $F800+XR_stringPtr
 addq.l #4,a7
 move.l a0,8(a2) ;insert >ln
 bra notkeypressv200 ;do nothing more
notdiamlnv200:
 cmp.w #$2103,d5 ;check if DIAMOND+sin
 bne notdiamsinv200
 pea.l 31 ;convert abs( to local string
 dc.w $F800+XR_stringPtr
 addq.l #4,a7
 move.w #$723,(a2) ;change event to CM_STRING
 move.l a0,8(a2) ;insert abs(
 bra notkeypressv200 ;do nothing more
notdiamsinv200:
 cmp.w #$2104,d5 ;check if DIAMOND+cos
 bne notdiamcosv200
 pea.l 615 ;convert nCr( to local string
 dc.w $F800+XR_stringPtr
 addq.l #4,a7
 move.w #$723,(a2) ;change event to CM_STRING
 move.l a0,8(a2) ;insert nCr(
 bra notkeypressv200 ;do nothing more
notdiamcosv200:
 cmp.w #$2105,d5 ;check if DIAMOND+tan
 bne notdiamtanv200
 pea.l 641 ;convert nPr( to local string
 dc.w $F800+XR_stringPtr
 addq.l #4,a7
 move.w #$723,(a2) ;change event to CM_STRING
 move.l a0,8(a2) ;insert nPr(
 bra notkeypressv200 ;do nothing more
notdiamtanv200:
 cmp.w #$2108,d5 ;check if DIAMOND+ESC
 bne notdiamescv200
 pea.l 3840
 dc.w $F800+HeapAllocPtr
 move.l a0,d4 ;save the address to d4
 tst.l d4
 beq diamescnomemv200 ;if NULL pointer, don't display key map
 pea.l $4c00
 move.l d4,-(a7)
 dc.w $F800+memcpy ;save the screen
 addq.l #8,a7
 lea.l classicmodev200(PC),a3
 move.b (a3),d5
keymapredrawv200:
 lea.l $4c00,a0
 lea.l keymapv200(PC),a1
 move.w #3840,d0
 bsr rledecodev200
 tst.b d5
 beq keymapnotclassicv200
 lea.l $4e94,a0 ;y=22
 lea.l classickeymapv200(PC),a1
 move.w #2400,d0 ;h=80
 bsr rledecodev200
keymapnotclassicv200:
 move.w #2,-(a7)
 dc.w $F800+FontSetSys
 move.w d0,(a7)
 clr.w -(a7)
 pea.l keymaptextv200(PC)
 move.l #$59006e,-(a7)
 dc.w $F800+DrawStr
 lea.l 10(a7),a7
 dc.w $F800+FontSetSys
 addq.l #2,a7
 dc.w $F800+ngetchx ;wait for a keypress
 cmp.w #337,d0 ;KEY_LEFT
 bne keymapnotleftv200
 st.b d5 ;enable classic mode
keymapnotleftv200:
 cmp.w #340,d0 ;KEY_RIGHT
 bne keymapnotrightv200
 clr.b d5 ;disable classic mode
keymapnotrightv200:
 cmp.w #264,d0 ;KEY_ESC
 beq keymapcancelv200
 cmp.w #13,d0 ;KEY_ENTER
 bne keymapredrawv200
 move.b d5,(a3)
keymapcancelv200:
 move.l d4,-(a7)
 pea.l $4c00
 dc.w $F800+memcpy ;restore the screen
 addq.l #4,a7
 move.l d4,(a7)
 dc.w $F800+HeapFreePtr
 addq.l #4,a7
diamescnomemv200:
 addq.l #4,a7
 move.w #$700,(a2) ;change event to CM_IDLE
 bra notkeypressv200 ;do nothing more
notdiamescv200:
 cmp.w #$2028,d5 ;check if DIAMOND+(
 bne notkeypressv200
 lea.l eventv200(PC),a0
 move.w #$710,(a0)
 lea.l event_keycodev200(PC),a0 ;insert the keycode of the Napier / Euler e into
 move.l #150*65536+150,(a0)     ;the event structure
 pea.l eventv200(PC) ;CM_KEYPRESS event for the Napier/Euler e
 move.w #-2,-(a7)
 dc.w $F800+EV_sendEvent ;send the CM_KEYPRESS event to the current application
 addq.l #6,a7 ;We have to send an additional event because we have to keep the
              ;self-test key working.
notkeypressv200:
 move.l oldeventv200(PC),a0 ;a0 = old event hook
 cmp.l #0,a0 ;check if 0 (tst refuses this addressing mode)
 beq nooldeventv200 ;if 0 do nothing
 move.l 64(a7),a2 ;pass event structure in a2 (for TeOS)
 move.l a2,-(a7) ;pass event structure as an argument
 jsr (a0) ;run the old event hook
 addq.l #4,a7
nooldeventv200:
 movem.l (a7)+,a0-a6/d0-d7 ;restore all registers
 rts ;return
rledecoderunv200:
 move.b (a1)+,d1 ;get the run value
 move.b (a1)+,d2 ;get the run count
rledecoderunloopv200:
 move.b d1,(a0)+ ;copy the byte
 subq.w #1,d0 ;decrease the byte count
 beq rledecodereturnv200 ;if 0, we're done
 subq.b #1,d2 ;decrease the run count
 bne rledecoderunloopv200 ;if we're not done, then loop
rledecodev200:
;Thanks to David Philips for the Z80 routine this is based on
 move.b (a1)+,d1 ;get the next byte
 cmp.b #$91,d1 ;is it a run?
 beq rledecoderunv200 ;then we need to decode the run
 move.b d1,(a0)+ ;copy the byte
 subq.w #1,d0 ;update the counter
 bne rledecodev200 ;if not 0, we're not done
rledecodereturnv200:
 rts ;if 0, we're done

 EVEN ;avoid silly alignment problems
      ;("Address Error" etc.)
statusflagsv200: dc.w 0 ;placeholder for the status flags
statusflags2v200: dc.w 0
paramsv200: dc.l $6016;position of the home screen entry line
                      ;parameters
windowv200: dc.l $6071;position of the 2nd byte of the home
                      ;screen window flags (containing the
                      ;"active" flag)
;Those values may be adjusted for different AMS versions.
eventv200: ;event structure for EV_sendEvent
 dc.w $710 ;type = CM_STRING
 ds.b 6 ;RunningApp (2), Side (2), StatusFlags (2)
event_keycodev200:
 dc.w 150,150 ;Mod (2), Code (2)
 ds.b 2 ;StartType (2)
keymapv200:
 dc.b $04,$1c,$91,$00,$03,$01,$07,$91,$00,$09,$01,$91,$00,$0d,$0a,$22,$91,$00,$03,$02,$88,$80,$91,$00,$08,$01,$91,$00,$0d,$11
 dc.b $02,$91,$00,$03,$04,$40,$80,$91,$00,$04,$01,$13,$e4,$40,$01,$91,$00,$0e,$04,$91,$00,$04,$07,$91,$00,$05,$01,$22,$02,$80
 dc.b $01,$91,$00,$0e,$08,$91,$00,$05,$80,$91,$00,$04,$01,$42,$01,$00,$01,$91,$00,$0e,$10,$91,$00,$04,$08,$80,$91,$00,$04,$01
 dc.b $83,$c1,$00,$01,$91,$00,$0e,$3e,$91,$00,$04,$07,$91,$00,$05,$01,$42,$01,$00,$01,$91,$00,$15,$0e,$22,$39,$f0,$01,$22,$01
 dc.b $00,$01,$91,$00,$15,$11,$22,$10,$40,$01,$13,$e1,$00,$01,$91,$00,$0d,$1f,$91,$ff,$06,$80,$11,$22,$10,$40,$91,$00,$04,$01
 dc.b $91,$00,$0d,$10,$91,$00,$06,$80,$11,$22,$10,$40,$91,$00,$04,$01,$91,$00,$0d,$10,$00,$88,$e3,$87,$c0,$00,$80,$11,$22,$10
 dc.b $40,$01,$10,$87,$80,$01,$91,$00,$06,$10,$00,$00,$10,$91,$00,$03,$10,$00,$d9,$12,$44,$00,$00,$80,$0e,$22,$10,$40,$01,$b1
 dc.b $44,$40,$01,$91,$00,$06,$10,$00,$00,$10,$91,$00,$03,$10,$00,$a9,$12,$24,$00,$00,$80,$01,$1c,$38,$40,$01,$52,$24,$40,$01
 dc.b $91,$00,$06,$10,$00,$00,$38,$91,$00,$03,$10,$00,$89,$12,$27,$80,$00,$80,$91,$00,$04,$01,$12,$27,$80,$01,$91,$00,$06,$10
 dc.b $00,$00,$38,$91,$00,$03,$10,$00,$89,$12,$24,$00,$00,$80,$91,$00,$04,$01,$13,$e4,$00,$01,$91,$00,$04,$0e,$2c,$70,$00,$00
 dc.b $7c,$91,$00,$03,$10,$00,$89,$12,$44,$00,$00,$80,$91,$00,$04,$01,$12,$24,$00,$01,$91,$00,$04,$11,$32,$90,$00,$00,$7c,$91
 dc.b $00,$03,$10,$00,$88,$e3,$87,$c0,$00,$80,$91,$00,$04,$01,$12,$24,$00,$01,$91,$00,$04,$20,$a2,$90,$00,$00,$fe,$91,$00,$03
 dc.b $10,$91,$00,$06,$80,$91,$00,$08,$01,$91,$00,$05,$a2,$60,$00,$00,$fe,$91,$00,$03,$1f,$91,$ff,$06,$80,$91,$00,$08,$01,$91
 dc.b $00,$03,$04,$00,$80,$00,$00,$81,$ff,$91,$00,$0c,$7f,$91,$ff,$03,$fc,$00,$00,$01,$91,$00,$03,$04,$00,$80,$00,$00,$81,$ff
 dc.b $91,$00,$0c,$40,$91,$00,$03,$04,$00,$00,$01,$91,$00,$03,$04,$01,$91,$00,$03,$83,$ff,$80,$00,$00,$04,$38,$20,$01,$80,$10
 dc.b $91,$00,$03,$40,$91,$00,$03,$04,$00,$00,$01,$91,$00,$03,$3f,$82,$00,$00,$07,$f3,$ff,$80,$00,$00,$0c,$44,$50,$10,$80,$10
 dc.b $91,$00,$03,$40,$91,$00,$03,$04,$00,$00,$01,$91,$00,$03,$04,$04,$91,$00,$03,$81,$ff,$91,$00,$03,$14,$44,$88,$18,$88,$98
 dc.b $cc,$80,$00,$5f,$f8,$1e,$01,$f4,$00,$00,$01,$91,$00,$03,$04,$08,$91,$00,$03,$81,$ff,$91,$00,$03,$04,$44,$00,$1c,$95,$55
 dc.b $51,$40,$00,$50,$00,$21,$02,$04,$00,$00,$01,$91,$00,$03,$04,$10,$91,$00,$03,$80,$fe,$91,$00,$03,$04,$44,$00,$18,$95,$55
 dc.b $4d,$80,$00,$50,$00,$40,$84,$04,$00,$00,$01,$91,$00,$04,$20,$91,$00,$04,$fe,$91,$00,$03,$04,$44,$00,$11,$c8,$c8,$d8,$c0
 dc.b $00,$50,$00,$80,$44,$04,$00,$00,$01,$91,$00,$04,$3f,$80,$91,$00,$03,$7c,$91,$00,$03,$0e,$38,$91,$00,$03,$40,$91,$00,$03
 dc.b $50,$00,$80,$08,$04,$00,$00,$01,$91,$00,$09,$7c,$91,$00,$07,$01,$80,$91,$00,$03,$50,$01,$00,$08,$04,$00,$00,$01,$91,$00
 dc.b $09,$38,$91,$00,$0c,$50,$01,$00,$08,$04,$00,$00,$01,$91,$00,$09,$38,$91,$00,$03,$1f,$91,$ff,$06,$80,$00,$50,$01,$00,$08
 dc.b $04,$00,$00,$01,$91,$00,$09,$10,$91,$00,$03,$10,$91,$00,$06,$80,$00,$50,$01,$00,$08,$04,$00,$00,$01,$91,$00,$09,$10,$91
 dc.b $00,$03,$10,$01,$c8,$1f,$08,$78,$00,$80,$00,$50,$01,$00,$08,$04,$00,$00,$01,$91,$00,$0d,$10,$02,$08,$10,$14,$44,$00,$80
 dc.b $00,$50,$01,$00,$08,$04,$00,$00,$01,$91,$00,$0d,$10,$04,$08,$10,$22,$44,$00,$80,$00,$50,$01,$00,$08,$04,$00,$00,$01,$91
 dc.b $00,$03,$3f,$91,$ff,$06,$91,$00,$03,$10,$04,$08,$1e,$22,$78,$00,$80,$00,$50,$00,$80,$08,$04,$00,$00,$01,$91,$00,$03,$3f
 dc.b $91,$ff,$06,$91,$00,$03,$10,$04,$08,$10,$3e,$50,$00,$80,$00,$50,$00,$80,$08,$04,$00,$00,$01,$91,$00,$03,$3f,$ff,$dd,$c1
 dc.b $df,$7f,$ff,$91,$00,$03,$10,$02,$08,$10,$22,$48,$00,$80,$00,$50,$00,$40,$08,$04,$00,$00,$01,$91,$00,$03,$3f,$ff,$db,$df
 dc.b $ee,$ff,$ff,$91,$00,$03,$10,$01,$cf,$9f,$22,$44,$00,$80,$00,$50,$00,$20,$08,$04,$00,$00,$01,$91,$00,$03,$3f,$ff,$d7,$df
 dc.b $f5,$ff,$ff,$91,$00,$03,$10,$91,$00,$06,$80,$00,$50,$00,$10,$08,$04,$00,$00,$01,$91,$00,$03,$3f,$ff,$cf,$c3,$fb,$ff,$ff
 dc.b $91,$00,$03,$1f,$91,$ff,$06,$80,$00,$50,$00,$08,$08,$04,$00,$00,$01,$91,$00,$03,$3f,$ff,$d7,$df,$fb,$ff,$ff,$91,$00,$0c
 dc.b $5f,$f0,$04,$08,$04,$00,$00,$01,$91,$00,$03,$3f,$ff,$db,$df,$fb,$ff,$ff,$91,$00,$0c,$50,$00,$02,$08,$04,$00,$00,$01,$91
 dc.b $00,$03,$3f,$ff,$dd,$df,$fb,$ff,$ff,$91,$00,$04,$10,$91,$00,$04,$60,$00,$00,$50,$00,$01,$08,$04,$00,$00,$01,$91,$00,$03
 dc.b $3f,$ff,$dd,$c1,$fb,$ff,$ff,$91,$00,$04,$28,$91,$00,$03,$04,$20,$00,$00,$50,$00,$00,$88,$04,$00,$00,$01,$91,$00,$03,$3f
 dc.b $91,$ff,$06,$91,$00,$03,$06,$44,$91,$00,$03,$06,$25,$00,$00,$50,$00,$00,$88,$04,$00,$00,$01,$91,$00,$03,$3f,$91,$ff,$06
 dc.b $91,$00,$03,$09,$91,$00,$04,$07,$26,$80,$00,$50,$00,$00,$48,$04,$00,$00,$01,$91,$00,$0d,$1e,$91,$00,$04,$06,$24,$80,$00
 dc.b $50,$00,$00,$48,$04,$00,$00,$01,$91,$00,$0d,$10,$91,$00,$04,$04,$24,$80,$00,$50,$00,$00,$48,$04,$00,$00,$01,$91,$00,$0d
 dc.b $0c,$91,$00,$05,$74,$80,$00,$50,$00,$00,$48,$04,$00,$00,$01,$91,$00,$16,$50,$00,$00,$48,$04,$00,$00,$01,$91,$00,$16,$50
 dc.b $00,$00,$48,$04,$00,$00,$01,$91,$00,$0d,$1f,$91,$ff,$06,$80,$00,$50,$00,$00,$48,$04,$00,$00,$01,$91,$00,$0d,$10,$91,$00
 dc.b $06,$80,$00,$50,$00,$00,$48,$04,$00,$00,$01,$91,$00,$0d,$10,$00,$00,$81,$10,$00,$00,$80,$00,$50,$00,$00,$48,$04,$00,$00
 dc.b $01,$91,$00,$0d,$10,$00,$00,$81,$90,$00,$00,$80,$00,$50,$00,$00,$88,$04,$00,$00,$01,$91,$00,$0d,$10,$00,$00,$81,$50,$00
 dc.b $00,$80,$00,$50,$01,$00,$84,$04,$00,$00,$01,$91,$00,$0d,$10,$00,$00,$81,$50,$00,$00,$80,$00,$50,$00,$81,$04,$04,$00,$00
 dc.b $01,$91,$00,$0d,$10,$00,$00,$81,$50,$00,$00,$80,$00,$50,$00,$42,$02,$04,$00,$00,$01,$91,$00,$0d,$10,$00,$00,$81,$30,$00
 dc.b $00,$80,$00,$5f,$fc,$3c,$01,$f4,$00,$00,$01,$91,$00,$0d,$10,$00,$00,$f9,$10,$00,$00,$80,$00,$40,$91,$00,$03,$04,$00,$00
 dc.b $01,$91,$ff,$0d,$10,$91,$00,$06,$80,$00,$40,$91,$00,$03,$04,$91,$00,$10,$1f,$91,$ff,$06,$80,$00,$7f,$91,$ff,$03,$fc,$91
 dc.b $00,$4e,$04,$91,$00,$07,$20,$91,$00,$06,$02,$91,$00,$0e,$0c,$91,$00,$07,$60,$91,$00,$06,$06,$91,$00,$0e,$64,$91,$00,$06
 dc.b $03,$20,$00,$00,$0e,$91,$00,$03,$32,$00,$00,$01,$e0,$91,$00,$07,$38,$00,$40,$04,$91,$00,$03,$80,$91,$00,$03,$20,$00,$00
 dc.b $11,$00,$10,$00,$02,$00,$00,$01,$10,$91,$00,$07,$40,$00,$00,$04,$91,$00,$03,$80,$91,$00,$03,$20,$00,$00,$10,$00,$10,$00
 dc.b $02,$00,$00,$01,$10,$91,$00,$07,$58,$0e,$ca,$91,$00,$03,$0a,$e3,$80,$e6,$38,$00,$00,$02,$90,$58,$1c,$55,$91,$00,$03,$29
 dc.b $15,$81,$f8,$91,$00,$05,$48,$10,$4d,$91,$00,$03,$16,$94,$01,$09,$40,$00,$00,$03,$50,$60,$10,$b6,$80,$00,$00,$35,$e6,$00
 dc.b $90,$91,$00,$05,$30,$0c,$49,$91,$00,$03,$12,$93,$01,$09,$30,$00,$00,$02,$50,$40,$10,$94,$80,$00,$00,$25,$04,$00,$90,$91
 dc.b $00,$06,$02,$49,$91,$00,$03,$16,$90,$81,$09,$08,$00,$00,$02,$51,$40,$12,$b4,$80,$00,$00,$25,$04,$00,$90,$91,$00,$06,$1c
 dc.b $e9,$91,$00,$03,$0a,$67,$00,$e6,$70,$00,$00,$02,$4e,$40,$0c,$54,$80,$00,$00,$25,$04,$00,$90,$91,$00,$42,$1f,$91,$ff,$06
 dc.b $81,$91,$ff,$06,$f8,$1f,$91,$ff,$06,$81,$91,$ff,$06,$f8,$10,$91,$00,$06,$81,$91,$00,$06,$08,$10,$91,$00,$06,$81,$91,$00
 dc.b $06,$08,$10,$00,$03,$87,$11,$00,$00,$81,$00,$00,$38,$e1,$c0,$00,$08,$10,$00,$0f,$84,$22,$00,$00,$81,$91,$00,$03,$10,$00
 dc.b $00,$08,$10,$00,$04,$42,$19,$00,$00,$81,$00,$00,$41,$12,$20,$00,$08,$10,$00,$02,$0a,$32,$00,$00,$81,$91,$00,$03,$28,$00
 dc.b $00,$08,$10,$00,$04,$02,$15,$00,$00,$81,$00,$00,$81,$12,$00,$00,$08,$10,$00,$02,$11,$2a,$00,$00,$81,$91,$00,$03,$44,$00
 dc.b $00,$08,$10,$00,$03,$82,$15,$00,$00,$81,$00,$00,$81,$11,$c0,$00,$08,$10,$00,$02,$11,$2a,$00,$00,$81,$91,$00,$06,$08,$10
 dc.b $00,$00,$42,$15,$00,$00,$81,$00,$00,$81,$10,$20,$00,$08,$10,$00,$02,$1f,$2a,$00,$00,$81,$91,$00,$06,$08,$10,$00,$04,$42
 dc.b $13,$00,$00,$81,$00,$00,$41,$12,$20,$00,$08,$10,$00,$02,$11,$26,$00,$00,$81,$91,$00,$06,$08,$10,$00,$03,$87,$11,$00,$00
 dc.b $81,$00,$00,$38,$e1,$c0,$00,$08,$10,$00,$02,$11,$22,$00,$00,$81,$91,$00,$06,$08,$10,$91,$00,$06,$81,$91,$00,$06,$08,$10
 dc.b $91,$00,$06,$81,$91,$00,$06,$08,$1f,$91,$ff,$06,$81,$91,$ff,$06,$f8,$1f,$91,$ff,$06,$81,$91,$ff,$06,$f8,$91,$00,$84,$1f
 dc.b $91,$ff,$05,$fe,$0f,$91,$ff,$04,$0f,$91,$ff,$04,$fc,$06,$91,$00,$0b,$10,$04,$91,$00,$03,$08,$02,$1f,$91,$ff,$04,$9f,$91
 dc.b $ff,$04,$fe,$08,$91,$00,$07,$40,$00,$00,$20,$10,$35,$10,$04,$00,$0b,$02,$1f,$91,$ff,$04,$9f,$91,$ff,$04,$fe,$08,$91,$00
 dc.b $05,$03,$00,$40,$00,$00,$21,$90,$f5,$b0,$04,$00,$0a,$c2,$1c,$7d,$ff,$ff,$6b,$9c,$7f,$fe,$7f,$ff,$de,$10,$91,$00,$05,$04
 dc.b $80,$40,$00,$00,$21,$93,$f5,$b0,$04,$00,$0a,$32,$1d,$fd,$ef,$c6,$ab,$9d,$ff,$c5,$ff,$fe,$de,$08,$91,$00,$05,$0f,$00,$41
 dc.b $d2,$64,$bc,$17,$f5,$53,$1c,$95,$6a,$0a,$1c,$44,$54,$7e,$a7,$9c,$66,$7d,$e4,$65,$5e,$08,$91,$00,$05,$08,$00,$42,$52,$94
 dc.b $a1,$93,$f5,$54,$a5,$59,$aa,$32,$1d,$d5,$cd,$c6,$ab,$9d,$ed,$c5,$d5,$5c,$de,$06,$91,$00,$05,$06,$00,$42,$4e,$94,$91,$91
 dc.b $01,$90,$f5,$14,$a5,$91,$91,$01,$2a,$c2,$1c,$56,$65,$ff,$6b,$9c,$4e,$7e,$65,$66,$6e,$91,$00,$08,$79,$c4,$63,$8c,$10,$35
 dc.b $13,$18,$d1,$2b,$02,$1f,$91,$ff,$04,$9f,$91,$ff,$04,$fe,$1f,$91,$ff,$06,$80,$00,$08,$00,$00,$10,$04,$91,$00,$03,$08,$02
 dc.b $1f,$91,$ff,$04,$9f,$91,$ff,$04,$fe,$10,$91,$00,$06,$80,$91,$00,$04,$1f,$91,$ff,$05,$fe,$0f,$91,$ff,$04,$0f,$91,$ff,$04
 dc.b $fc,$10,$00,$00,$01,$91,$00,$03,$80,$91,$00,$16,$10,$00,$00,$02,$91,$00,$03,$80,$91,$00,$16,$10,$00,$00,$04,$91,$00,$03
 dc.b $80,$91,$00,$16,$10,$00,$00,$04,$91,$00,$03,$80,$91,$00,$16,$10,$00,$00,$04,$91,$00,$03,$80,$00,$1f,$91,$ff,$13,$80,$10
 dc.b $00,$00,$02,$91,$00,$03,$80,$00,$7f,$91,$ff,$13,$e0,$10,$00,$00,$01,$91,$00,$03,$80,$00,$91,$ff,$14,$f0,$10,$91,$00,$06
 dc.b $80,$01,$91,$ff,$14,$f8,$1f,$91,$ff,$06,$80,$03,$91,$ff,$14,$fc,$91,$00,$08,$03,$91,$ff,$14,$fc,$91,$00,$08,$07,$91,$ff
 dc.b $14,$fe,$91,$00,$08,$07,$91,$ff,$14,$fe,$91,$00,$08,$07,$91,$ff,$14,$fe,$91,$00,$08,$07,$91,$ff,$14,$fe,$91,$00,$08,$07
 dc.b $91,$ff,$14,$fe,$91,$00,$08,$07,$91,$ff,$14,$fe,$91,$00,$08,$07,$91,$ff,$14,$fe,$91,$00,$08,$03,$f0,$73,$bb,$1d,$6f,$df
 dc.b $d7,$eb,$7f,$ee,$df,$fb,$5b,$ff,$fe,$ff,$ff,$ec,$ff,$ef,$fc,$91,$00,$08,$03,$e3,$3d,$55,$7c,$d5,$73,$ce,$da,$ab,$e2,$49
 dc.b $b6,$ce,$6a,$aa,$f3,$61,$da,$d6,$7c,$fc,$91,$00,$08,$01,$e4,$3b,$55,$9c,$cd,$55,$cd,$4a,$67,$ea,$da,$f6,$da,$aa,$a6,$ee
 dc.b $aa,$d8,$56,$eb,$f8,$91,$00,$09,$e3,$31,$bb,$3d,$66,$d5,$d6,$db,$2f,$eb,$69,$ad,$ea,$b7,$2e,$b3,$6a,$be,$e4,$ec,$f0,$91
 dc.b $00,$09,$70,$7f,$91,$ff,$08,$fb,$ff,$ff,$ef,$91,$ff,$05,$df,$e0,$91,$00,$09,$1f,$91,$ff,$13,$80,$91,$00,$1e
classickeymapv200:
 dc.b $04,$38,$20,$00,$00,$0c,$91,$00,$03,$40,$91,$00,$03,$04,$00,$00,$01,$91,$00,$03,$3f,$82,$00,$00,$07,$f3,$ff,$80,$00,$00
 dc.b $0c,$44,$50,$00,$00,$04,$91,$00,$03,$40,$91,$00,$03,$04,$00,$00,$01,$91,$00,$03,$04,$04,$91,$00,$03,$81,$ff,$91,$00,$03
 dc.b $14,$44,$88,$00,$00,$04,$63,$00,$00,$5f,$f8,$1e,$01,$f4,$00,$00,$01,$91,$00,$03,$04,$08,$91,$00,$03,$81,$ff,$91,$00,$03
 dc.b $04,$44,$91,$00,$03,$04,$94,$80,$00,$50,$00,$21,$02,$04,$00,$00,$01,$91,$00,$03,$04,$10,$91,$00,$03,$80,$fe,$91,$00,$03
 dc.b $04,$44,$91,$00,$03,$04,$94,$80,$00,$50,$00,$40,$84,$04,$00,$00,$01,$91,$00,$04,$20,$91,$00,$04,$fe,$91,$00,$03,$04,$44
 dc.b $91,$00,$03,$0e,$63,$80,$00,$50,$00,$80,$44,$04,$00,$00,$01,$91,$00,$04,$3f,$80,$91,$00,$03,$7c,$91,$00,$03,$0e,$38,$91
 dc.b $00,$05,$80,$00,$50,$00,$80,$08,$04,$00,$00,$01,$91,$00,$09,$7c,$91,$00,$09,$07,$00,$00,$50,$01,$00,$08,$04,$00,$00,$01
 dc.b $91,$00,$09,$38,$91,$00,$0c,$50,$01,$00,$08,$04,$00,$00,$01,$91,$00,$09,$38,$91,$00,$03,$1f,$91,$ff,$06,$80,$00,$50,$01
 dc.b $00,$08,$04,$00,$00,$01,$91,$00,$09,$10,$91,$00,$03,$10,$91,$00,$06,$80,$00,$50,$01,$00,$08,$04,$00,$00,$01,$91,$00,$09
 dc.b $10,$91,$00,$03,$10,$01,$c8,$1f,$08,$78,$00,$80,$00,$50,$01,$00,$08,$04,$00,$00,$01,$91,$00,$0d,$10,$02,$08,$10,$14,$44
 dc.b $00,$80,$00,$50,$01,$00,$08,$04,$00,$00,$01,$91,$00,$0d,$10,$04,$08,$10,$22,$44,$00,$80,$00,$50,$01,$00,$08,$04,$00,$00
 dc.b $01,$91,$00,$03,$3f,$91,$ff,$06,$91,$00,$03,$10,$04,$08,$1e,$22,$78,$00,$80,$00,$50,$00,$80,$08,$04,$00,$00,$01,$91,$00
 dc.b $03,$3f,$91,$ff,$06,$91,$00,$03,$10,$04,$08,$10,$3e,$50,$00,$80,$00,$50,$00,$80,$08,$04,$00,$00,$01,$91,$00,$03,$3f,$ff
 dc.b $dd,$c1,$df,$7f,$ff,$91,$00,$03,$10,$02,$08,$10,$22,$48,$00,$80,$00,$50,$00,$40,$08,$04,$00,$00,$01,$91,$00,$03,$3f,$ff
 dc.b $db,$df,$ee,$ff,$ff,$91,$00,$03,$10,$01,$cf,$9f,$22,$44,$00,$80,$00,$50,$00,$20,$08,$04,$00,$00,$01,$91,$00,$03,$3f,$ff
 dc.b $d7,$df,$f5,$ff,$ff,$91,$00,$03,$10,$91,$00,$06,$80,$00,$50,$00,$10,$08,$04,$00,$00,$01,$91,$00,$03,$3f,$ff,$cf,$c3,$fb
 dc.b $ff,$ff,$91,$00,$03,$1f,$91,$ff,$06,$80,$00,$50,$00,$08,$08,$04,$00,$00,$01,$91,$00,$03,$3f,$ff,$d7,$df,$fb,$ff,$ff,$91
 dc.b $00,$0c,$5f,$f0,$04,$08,$04,$00,$00,$01,$91,$00,$03,$3f,$ff,$db,$df,$fb,$ff,$ff,$91,$00,$0c,$50,$00,$02,$08,$04,$00,$00
 dc.b $01,$91,$00,$03,$3f,$ff,$dd,$df,$fb,$ff,$ff,$91,$00,$04,$10,$91,$00,$04,$03,$80,$00,$50,$00,$01,$08,$04,$00,$00,$01,$91
 dc.b $00,$03,$3f,$ff,$dd,$c1,$fb,$ff,$ff,$91,$00,$04,$28,$91,$00,$04,$04,$00,$00,$50,$00,$00,$88,$04,$00,$00,$01,$91,$00,$03
 dc.b $3f,$91,$ff,$06,$91,$00,$03,$06,$44,$91,$00,$04,$05,$80,$00,$50,$00,$00,$88,$04,$00,$00,$01,$91,$00,$03,$3f,$91,$ff,$06
 dc.b $91,$00,$03,$09,$91,$00,$05,$04,$80,$00,$50,$00,$00,$48,$04,$00,$00,$01,$91,$00,$0d,$1e,$91,$00,$05,$03,$00,$00,$50,$00
 dc.b $00,$48,$04,$00,$00,$01,$91,$00,$0d,$10,$91,$00,$08,$50,$00,$00,$48,$04,$00,$00,$01,$91,$00,$0d,$0c,$91,$00,$08,$50,$00
 dc.b $00,$48,$04,$00,$00,$01,$91,$00,$16,$50,$00,$00,$48,$04,$00,$00,$01,$91,$00,$16,$50,$00,$00,$48,$04,$00,$00,$01,$91,$00
 dc.b $0d,$1f,$91,$ff,$06,$80,$00,$50,$00,$00,$48,$04,$00,$00,$01,$91,$00,$0d,$10,$91,$00,$06,$80,$00,$50,$00,$00,$48,$04,$00
 dc.b $00,$01,$91,$00,$0d,$10,$00,$00,$81,$10,$00,$00,$80,$00,$50,$00,$00,$48,$04,$00,$00,$01,$91,$00,$0d,$10,$00,$00,$81,$90
 dc.b $00,$00,$80,$00,$50,$00,$00,$88,$04,$00,$00,$01,$91,$00,$0d,$10,$00,$00,$81,$50,$00,$00,$80,$00,$50,$01,$00,$84,$04,$00
 dc.b $00,$01,$91,$00,$0d,$10,$00,$00,$81,$50,$00,$00,$80,$00,$50,$00,$81,$04,$04,$00,$00,$01,$91,$00,$0d,$10,$00,$00,$81,$50
 dc.b $00,$00,$80,$00,$50,$00,$42,$02,$04,$00,$00,$01,$91,$00,$0d,$10,$00,$00,$81,$30,$00,$00,$80,$00,$5f,$fc,$3c,$01,$f4,$00
 dc.b $00,$01,$91,$00,$0d,$10,$00,$00,$f9,$10,$00,$00,$80,$00,$40,$91,$00,$03,$04,$00,$00,$01,$91,$ff,$0d,$10,$91,$00,$06,$80
 dc.b $00,$40,$91,$00,$03,$04,$91,$00,$10,$1f,$91,$ff,$06,$80,$00,$7f,$91,$ff,$03,$fc,$91,$00,$4e,$04,$91,$00,$07,$20,$91,$00
 dc.b $06,$02,$91,$00,$0e,$0c,$91,$00,$07,$60,$91,$00,$06,$06,$91,$00,$0e,$64,$91,$00,$06,$03,$20,$00,$00,$0e,$91,$00,$03,$32
 dc.b $00,$00,$01,$e0,$91,$00,$06,$28,$00,$00,$40,$04,$91,$00,$03,$80,$91,$00,$03,$20,$00,$00,$11,$00,$10,$00,$02,$00,$00,$01
 dc.b $10,$91,$00,$06,$10,$91,$00,$03,$04,$91,$00,$03,$80,$91,$00,$03,$20,$00,$00,$10,$00,$10,$00,$02,$00,$00,$01,$10,$91,$00
 dc.b $06,$29,$f8,$0e,$ca,$91,$00,$03,$0a,$e3,$80,$e6,$38,$00,$00,$02,$90,$58,$1c,$55,$91,$00,$03,$29,$15,$81,$f8,$91,$00,$04
 dc.b $02,$00,$10,$4d,$91,$00,$03,$16,$94,$01,$09,$40,$00,$00,$03,$50,$60,$10,$b6,$80,$00,$00,$35,$e6,$00,$90,$91,$00,$04,$02
 dc.b $00,$0c,$49,$91,$00,$03,$12,$93,$01,$09,$30,$00,$00,$02,$50,$40,$10,$94,$80,$00,$00,$25,$04,$00,$90,$91,$00,$04,$24,$00
 dc.b $02,$49,$91,$00,$03,$16,$90,$81,$09,$08,$00,$00,$02,$51,$40,$12,$b4,$80,$00,$00,$25,$04,$00,$90,$91,$00,$04,$14,$00,$1c
 dc.b $e9,$91,$00,$03,$0a,$67,$00,$e6,$70,$00,$00,$02,$4e,$40,$0c,$54,$80,$00,$00,$25,$04,$00,$90,$91,$00,$04,$08,$91,$00,$3d
 dc.b $1f,$91,$ff,$06,$81,$91,$ff,$06,$f8,$1f,$91,$ff,$06,$81,$91,$ff,$06,$f8,$10,$91,$00,$06,$81,$91,$00,$06,$08,$10,$91,$00
 dc.b $06,$81,$91,$00,$06,$08,$10,$00,$03,$87,$11,$00,$00,$81,$00,$00,$38,$e1,$c0,$00,$08,$10,$00,$0f,$84,$22,$00,$00,$81,$91
 dc.b $00,$03,$10,$00,$00,$08,$10,$00,$04,$42,$19,$00,$00,$81,$00,$00,$41,$12,$20,$00,$08,$10,$00,$02,$0a,$32,$00,$00,$81,$91
 dc.b $00,$03,$28,$00,$00,$08,$10,$00,$04,$02,$15,$00,$00,$81,$00,$00,$81,$12,$00,$00,$08,$10,$00,$02,$11,$2a,$00,$00,$81,$91
 dc.b $00,$03,$44,$00,$00,$08,$10,$00,$03,$82,$15,$00,$00,$81,$00,$00,$81,$11,$c0,$00,$08,$10,$00,$02,$11,$2a,$00,$00,$81,$91
 dc.b $00,$06,$08,$10,$00,$00,$42,$15,$00,$00,$81,$00,$00,$81,$10,$20,$00,$08,$10,$00,$02,$1f,$2a,$00,$00,$81,$91,$00,$06,$08
 dc.b $10,$00,$04,$42,$13,$00,$00,$81,$00,$00,$41,$12,$20,$00,$08,$10,$00,$02,$11,$26,$00,$00,$81,$91,$00,$06,$08,$10,$00,$03
 dc.b $87,$11,$00,$00,$81,$00,$00,$38,$e1,$c0,$00,$08,$10,$00,$02,$11,$22,$00,$00,$81,$91,$00,$06,$08,$10,$91,$00,$06,$81,$91
 dc.b $00,$06,$08,$10,$91,$00,$06,$81,$91,$00,$06,$08,$1f,$91,$ff,$06,$81,$91,$ff,$06,$f8,$1f,$91,$ff,$06,$81,$91,$ff,$06,$f8
 dc.b $91,$00,$84,$1f,$91,$ff,$05,$fe,$0f,$91,$ff,$04,$0f,$91,$ff,$04,$fc,$06,$91,$00,$0b,$10,$04,$91,$00,$03,$08,$02,$1f,$91
 dc.b $ff,$04,$9f,$91,$ff,$04,$fe,$08,$91,$00,$07,$40,$00,$00,$20,$10,$34,$c8,$00,$00,$0b,$02,$1f,$91,$ff,$04,$9f,$91,$ff,$04
 dc.b $fe,$08,$91,$00,$05,$03,$00,$40,$00,$00,$21,$90,$d5,$28,$00,$04,$0b,$c2,$1c,$7d,$ff,$ff,$6b,$9c,$7f,$fe,$7f,$ff,$de,$10
 dc.b $91,$00,$05,$04,$80,$40,$00,$00,$21,$93,$15,$08,$00,$00,$0b,$f2,$1d,$fd,$ef,$c6,$ab,$9d,$ff,$c5,$ff,$fe,$de,$08,$91,$00
 dc.b $05,$0f,$00,$41,$d2,$64,$bc,$14,$15,$08,$73,$34,$eb,$fa,$1c,$44,$54,$7e,$a7,$9c,$66,$7d,$e4,$65,$5e,$08,$91,$00,$05,$08
 dc.b $00,$42,$52,$94,$a1,$93,$15,$08,$94,$45,$0b,$f2,$1d,$d5,$cd,$c6,$ab,$9d,$ed,$c5,$d5,$5c,$de,$06,$91,$00,$05,$06,$00,$42
 dc.b $4e,$94,$91,$91,$01,$90,$d5,$2a,$93,$35,$2b,$c2,$1c,$56,$65,$ff,$6b,$9c,$4e,$7e,$65,$66,$6e,$91,$00,$08,$79,$c4,$63,$8c
 dc.b $10,$34,$c4,$76,$64,$cb,$02,$1f,$91,$ff,$04,$9f,$91,$ff,$04,$fe
keymaptextv200: dc.b 'XtraKeys v. 3.00',0
txt_10expv200: dc.b '10^(',0
txt_squarev200: dc.b '^2',0
txt_cubev200: dc.b '^3',0
txt_gradv200: dc.b 170,0
kbdprgmcallv200: dc.w endkbdprgmcallv200-startkbdprgmcallv200
startkbdprgmcallv200: dc.b $e9,$e5,0,'main\kbdprgm'
kbdprgmnov200: dc.b '7',0,$da
endkbdprgmcallv200:
funcbufferv200: ds.b 21
classicmodev200: dc.b 0 ;non-0: classic mode, 0: modern mode
endeventv200:

;byte-aligned data here:
installedST: dc.b 'XtraKeys 3.00 by Kevin Kofler installed',0
nomemST: dc.b 'ERROR: not enough memory',0
 dc.b 'x'
foldersym: dc.b 0
 dc.b 'x\root'
rootsym: dc.b 0
 dc.b 'x\logy'
logysym: dc.b 0
rootdata:
;This is tokenized TI-BASIC for:
;x\root(x,y)=y^(1/x)
 dc.b 0,17,$e9,1,1,$1f,8,$f0,$91,9,$f0,$93,$e5,9,8,0,1,$40,$dc
logydata:
;This is tokenized TI-BASIC for:
;x\logy(x,y)=ln(y)/ln(x)
 dc.b 0,15,$e9,9,$f0,$53,8,$f0,$53,$91,$e5,9,8,0,1,$40,$dc
tidsktop: dc.b 'TIDSKTOP',0
_nostub_data__0000: ;comment
 dc.b 'XtraKeys 3.00 by Kevin Kofler',0

 END
